<a id="mypy-boto3-sagemaker"></a>

# mypy-boto3-sagemaker

[![PyPI - mypy-boto3-sagemaker](https://img.shields.io/pypi/v/mypy-boto3-sagemaker.svg?color=blue)](https://pypi.org/project/mypy-boto3-sagemaker)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-sagemaker.svg?color=blue)](https://pypi.org/project/mypy-boto3-sagemaker)
[![Docs](https://img.shields.io/readthedocs/boto3-stubs.svg?color=blue)](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_sagemaker/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/mypy-boto3-sagemaker?color=blue)](https://pypistats.org/packages/mypy-boto3-sagemaker)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.SageMaker 1.28.3](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/sagemaker.html#SageMaker)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.14.7](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-sagemaker docs](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_sagemaker/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-sagemaker](#mypy-boto3-sagemaker)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `SageMaker`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `boto3-stubs` for `SageMaker` service.

```bash
# install with boto3 type annotations
python -m pip install 'boto3-stubs[sagemaker]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'boto3-stubs-lite[sagemaker]'


# standalone installation
python -m pip install mypy-boto3-sagemaker
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y mypy-boto3-sagemaker
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto3-stubs[sagemaker]` in your environment:

```bash
python -m pip install 'boto3-stubs[sagemaker]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `boto3-stubs-lite[sagemaker]` in your environment:

```bash
python -m pip install 'boto3-stubs-lite[sagemaker]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `boto3-stubs` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `boto3-stubs` with services you use in your environment:

```bash
python -m pip install 'boto3-stubs[sagemaker]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed `boto3-stubs`

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `boto3-stubs[sagemaker]` with services you use in your environment:

```bash
python -m pip install 'boto3-stubs[sagemaker]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto3-stubs[sagemaker]` in your environment:

```bash
python -m pip install 'boto3-stubs[sagemaker]'`
```

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `boto3-stubs[sagemaker]` in your environment:

```bash
python -m pip install 'boto3-stubs[sagemaker]'
```

Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`SageMakerClient` provides annotations for `boto3.client("sagemaker")`.

```python
from boto3.session import Session

from mypy_boto3_sagemaker import SageMakerClient

client: SageMakerClient = Session().client("sagemaker")

# now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_sagemaker.paginator` module contains type annotations for all
paginators.

```python
from boto3.session import Session

from mypy_boto3_sagemaker import SageMakerClient
from mypy_boto3_sagemaker.paginator import (
    ListActionsPaginator,
    ListAlgorithmsPaginator,
    ListAliasesPaginator,
    ListAppImageConfigsPaginator,
    ListAppsPaginator,
    ListArtifactsPaginator,
    ListAssociationsPaginator,
    ListAutoMLJobsPaginator,
    ListCandidatesForAutoMLJobPaginator,
    ListCodeRepositoriesPaginator,
    ListCompilationJobsPaginator,
    ListContextsPaginator,
    ListDataQualityJobDefinitionsPaginator,
    ListDeviceFleetsPaginator,
    ListDevicesPaginator,
    ListDomainsPaginator,
    ListEdgeDeploymentPlansPaginator,
    ListEdgePackagingJobsPaginator,
    ListEndpointConfigsPaginator,
    ListEndpointsPaginator,
    ListExperimentsPaginator,
    ListFeatureGroupsPaginator,
    ListFlowDefinitionsPaginator,
    ListHumanTaskUisPaginator,
    ListHyperParameterTuningJobsPaginator,
    ListImageVersionsPaginator,
    ListImagesPaginator,
    ListInferenceExperimentsPaginator,
    ListInferenceRecommendationsJobStepsPaginator,
    ListInferenceRecommendationsJobsPaginator,
    ListLabelingJobsPaginator,
    ListLabelingJobsForWorkteamPaginator,
    ListLineageGroupsPaginator,
    ListModelBiasJobDefinitionsPaginator,
    ListModelCardExportJobsPaginator,
    ListModelCardVersionsPaginator,
    ListModelCardsPaginator,
    ListModelExplainabilityJobDefinitionsPaginator,
    ListModelMetadataPaginator,
    ListModelPackageGroupsPaginator,
    ListModelPackagesPaginator,
    ListModelQualityJobDefinitionsPaginator,
    ListModelsPaginator,
    ListMonitoringAlertHistoryPaginator,
    ListMonitoringAlertsPaginator,
    ListMonitoringExecutionsPaginator,
    ListMonitoringSchedulesPaginator,
    ListNotebookInstanceLifecycleConfigsPaginator,
    ListNotebookInstancesPaginator,
    ListPipelineExecutionStepsPaginator,
    ListPipelineExecutionsPaginator,
    ListPipelineParametersForExecutionPaginator,
    ListPipelinesPaginator,
    ListProcessingJobsPaginator,
    ListSpacesPaginator,
    ListStageDevicesPaginator,
    ListStudioLifecycleConfigsPaginator,
    ListSubscribedWorkteamsPaginator,
    ListTagsPaginator,
    ListTrainingJobsPaginator,
    ListTrainingJobsForHyperParameterTuningJobPaginator,
    ListTransformJobsPaginator,
    ListTrialComponentsPaginator,
    ListTrialsPaginator,
    ListUserProfilesPaginator,
    ListWorkforcesPaginator,
    ListWorkteamsPaginator,
    SearchPaginator,
)

client: SageMakerClient = Session().client("sagemaker")

# Explicit type annotations are optional here
# Types should be correctly discovered by mypy and IDEs
list_actions_paginator: ListActionsPaginator = client.get_paginator("list_actions")
list_algorithms_paginator: ListAlgorithmsPaginator = client.get_paginator("list_algorithms")
list_aliases_paginator: ListAliasesPaginator = client.get_paginator("list_aliases")
list_app_image_configs_paginator: ListAppImageConfigsPaginator = client.get_paginator(
    "list_app_image_configs"
)
list_apps_paginator: ListAppsPaginator = client.get_paginator("list_apps")
list_artifacts_paginator: ListArtifactsPaginator = client.get_paginator("list_artifacts")
list_associations_paginator: ListAssociationsPaginator = client.get_paginator("list_associations")
list_auto_ml_jobs_paginator: ListAutoMLJobsPaginator = client.get_paginator("list_auto_ml_jobs")
list_candidates_for_auto_ml_job_paginator: ListCandidatesForAutoMLJobPaginator = (
    client.get_paginator("list_candidates_for_auto_ml_job")
)
list_code_repositories_paginator: ListCodeRepositoriesPaginator = client.get_paginator(
    "list_code_repositories"
)
list_compilation_jobs_paginator: ListCompilationJobsPaginator = client.get_paginator(
    "list_compilation_jobs"
)
list_contexts_paginator: ListContextsPaginator = client.get_paginator("list_contexts")
list_data_quality_job_definitions_paginator: ListDataQualityJobDefinitionsPaginator = (
    client.get_paginator("list_data_quality_job_definitions")
)
list_device_fleets_paginator: ListDeviceFleetsPaginator = client.get_paginator("list_device_fleets")
list_devices_paginator: ListDevicesPaginator = client.get_paginator("list_devices")
list_domains_paginator: ListDomainsPaginator = client.get_paginator("list_domains")
list_edge_deployment_plans_paginator: ListEdgeDeploymentPlansPaginator = client.get_paginator(
    "list_edge_deployment_plans"
)
list_edge_packaging_jobs_paginator: ListEdgePackagingJobsPaginator = client.get_paginator(
    "list_edge_packaging_jobs"
)
list_endpoint_configs_paginator: ListEndpointConfigsPaginator = client.get_paginator(
    "list_endpoint_configs"
)
list_endpoints_paginator: ListEndpointsPaginator = client.get_paginator("list_endpoints")
list_experiments_paginator: ListExperimentsPaginator = client.get_paginator("list_experiments")
list_feature_groups_paginator: ListFeatureGroupsPaginator = client.get_paginator(
    "list_feature_groups"
)
list_flow_definitions_paginator: ListFlowDefinitionsPaginator = client.get_paginator(
    "list_flow_definitions"
)
list_human_task_uis_paginator: ListHumanTaskUisPaginator = client.get_paginator(
    "list_human_task_uis"
)
list_hyper_parameter_tuning_jobs_paginator: ListHyperParameterTuningJobsPaginator = (
    client.get_paginator("list_hyper_parameter_tuning_jobs")
)
list_image_versions_paginator: ListImageVersionsPaginator = client.get_paginator(
    "list_image_versions"
)
list_images_paginator: ListImagesPaginator = client.get_paginator("list_images")
list_inference_experiments_paginator: ListInferenceExperimentsPaginator = client.get_paginator(
    "list_inference_experiments"
)
list_inference_recommendations_job_steps_paginator: ListInferenceRecommendationsJobStepsPaginator = client.get_paginator(
    "list_inference_recommendations_job_steps"
)
list_inference_recommendations_jobs_paginator: ListInferenceRecommendationsJobsPaginator = (
    client.get_paginator("list_inference_recommendations_jobs")
)
list_labeling_jobs_paginator: ListLabelingJobsPaginator = client.get_paginator("list_labeling_jobs")
list_labeling_jobs_for_workteam_paginator: ListLabelingJobsForWorkteamPaginator = (
    client.get_paginator("list_labeling_jobs_for_workteam")
)
list_lineage_groups_paginator: ListLineageGroupsPaginator = client.get_paginator(
    "list_lineage_groups"
)
list_model_bias_job_definitions_paginator: ListModelBiasJobDefinitionsPaginator = (
    client.get_paginator("list_model_bias_job_definitions")
)
list_model_card_export_jobs_paginator: ListModelCardExportJobsPaginator = client.get_paginator(
    "list_model_card_export_jobs"
)
list_model_card_versions_paginator: ListModelCardVersionsPaginator = client.get_paginator(
    "list_model_card_versions"
)
list_model_cards_paginator: ListModelCardsPaginator = client.get_paginator("list_model_cards")
list_model_explainability_job_definitions_paginator: ListModelExplainabilityJobDefinitionsPaginator = client.get_paginator(
    "list_model_explainability_job_definitions"
)
list_model_metadata_paginator: ListModelMetadataPaginator = client.get_paginator(
    "list_model_metadata"
)
list_model_package_groups_paginator: ListModelPackageGroupsPaginator = client.get_paginator(
    "list_model_package_groups"
)
list_model_packages_paginator: ListModelPackagesPaginator = client.get_paginator(
    "list_model_packages"
)
list_model_quality_job_definitions_paginator: ListModelQualityJobDefinitionsPaginator = (
    client.get_paginator("list_model_quality_job_definitions")
)
list_models_paginator: ListModelsPaginator = client.get_paginator("list_models")
list_monitoring_alert_history_paginator: ListMonitoringAlertHistoryPaginator = client.get_paginator(
    "list_monitoring_alert_history"
)
list_monitoring_alerts_paginator: ListMonitoringAlertsPaginator = client.get_paginator(
    "list_monitoring_alerts"
)
list_monitoring_executions_paginator: ListMonitoringExecutionsPaginator = client.get_paginator(
    "list_monitoring_executions"
)
list_monitoring_schedules_paginator: ListMonitoringSchedulesPaginator = client.get_paginator(
    "list_monitoring_schedules"
)
list_notebook_instance_lifecycle_configs_paginator: ListNotebookInstanceLifecycleConfigsPaginator = client.get_paginator(
    "list_notebook_instance_lifecycle_configs"
)
list_notebook_instances_paginator: ListNotebookInstancesPaginator = client.get_paginator(
    "list_notebook_instances"
)
list_pipeline_execution_steps_paginator: ListPipelineExecutionStepsPaginator = client.get_paginator(
    "list_pipeline_execution_steps"
)
list_pipeline_executions_paginator: ListPipelineExecutionsPaginator = client.get_paginator(
    "list_pipeline_executions"
)
list_pipeline_parameters_for_execution_paginator: ListPipelineParametersForExecutionPaginator = (
    client.get_paginator("list_pipeline_parameters_for_execution")
)
list_pipelines_paginator: ListPipelinesPaginator = client.get_paginator("list_pipelines")
list_processing_jobs_paginator: ListProcessingJobsPaginator = client.get_paginator(
    "list_processing_jobs"
)
list_spaces_paginator: ListSpacesPaginator = client.get_paginator("list_spaces")
list_stage_devices_paginator: ListStageDevicesPaginator = client.get_paginator("list_stage_devices")
list_studio_lifecycle_configs_paginator: ListStudioLifecycleConfigsPaginator = client.get_paginator(
    "list_studio_lifecycle_configs"
)
list_subscribed_workteams_paginator: ListSubscribedWorkteamsPaginator = client.get_paginator(
    "list_subscribed_workteams"
)
list_tags_paginator: ListTagsPaginator = client.get_paginator("list_tags")
list_training_jobs_paginator: ListTrainingJobsPaginator = client.get_paginator("list_training_jobs")
list_training_jobs_for_hyper_parameter_tuning_job_paginator: ListTrainingJobsForHyperParameterTuningJobPaginator = client.get_paginator(
    "list_training_jobs_for_hyper_parameter_tuning_job"
)
list_transform_jobs_paginator: ListTransformJobsPaginator = client.get_paginator(
    "list_transform_jobs"
)
list_trial_components_paginator: ListTrialComponentsPaginator = client.get_paginator(
    "list_trial_components"
)
list_trials_paginator: ListTrialsPaginator = client.get_paginator("list_trials")
list_user_profiles_paginator: ListUserProfilesPaginator = client.get_paginator("list_user_profiles")
list_workforces_paginator: ListWorkforcesPaginator = client.get_paginator("list_workforces")
list_workteams_paginator: ListWorkteamsPaginator = client.get_paginator("list_workteams")
search_paginator: SearchPaginator = client.get_paginator("search")
```

<a id="waiters-annotations"></a>

### Waiters annotations

`mypy_boto3_sagemaker.waiter` module contains type annotations for all waiters.

```python
from boto3.session import Session

from mypy_boto3_sagemaker import SageMakerClient
from mypy_boto3_sagemaker.waiter import (
    EndpointDeletedWaiter,
    EndpointInServiceWaiter,
    ImageCreatedWaiter,
    ImageDeletedWaiter,
    ImageUpdatedWaiter,
    ImageVersionCreatedWaiter,
    ImageVersionDeletedWaiter,
    NotebookInstanceDeletedWaiter,
    NotebookInstanceInServiceWaiter,
    NotebookInstanceStoppedWaiter,
    ProcessingJobCompletedOrStoppedWaiter,
    TrainingJobCompletedOrStoppedWaiter,
    TransformJobCompletedOrStoppedWaiter,
)

client: SageMakerClient = Session().client("sagemaker")

# Explicit type annotations are optional here
# Types should be correctly discovered by mypy and IDEs
endpoint_deleted_waiter: EndpointDeletedWaiter = client.get_waiter("endpoint_deleted")
endpoint_in_service_waiter: EndpointInServiceWaiter = client.get_waiter("endpoint_in_service")
image_created_waiter: ImageCreatedWaiter = client.get_waiter("image_created")
image_deleted_waiter: ImageDeletedWaiter = client.get_waiter("image_deleted")
image_updated_waiter: ImageUpdatedWaiter = client.get_waiter("image_updated")
image_version_created_waiter: ImageVersionCreatedWaiter = client.get_waiter("image_version_created")
image_version_deleted_waiter: ImageVersionDeletedWaiter = client.get_waiter("image_version_deleted")
notebook_instance_deleted_waiter: NotebookInstanceDeletedWaiter = client.get_waiter(
    "notebook_instance_deleted"
)
notebook_instance_in_service_waiter: NotebookInstanceInServiceWaiter = client.get_waiter(
    "notebook_instance_in_service"
)
notebook_instance_stopped_waiter: NotebookInstanceStoppedWaiter = client.get_waiter(
    "notebook_instance_stopped"
)
processing_job_completed_or_stopped_waiter: ProcessingJobCompletedOrStoppedWaiter = (
    client.get_waiter("processing_job_completed_or_stopped")
)
training_job_completed_or_stopped_waiter: TrainingJobCompletedOrStoppedWaiter = client.get_waiter(
    "training_job_completed_or_stopped"
)
transform_job_completed_or_stopped_waiter: TransformJobCompletedOrStoppedWaiter = client.get_waiter(
    "transform_job_completed_or_stopped"
)
```

<a id="literals"></a>

### Literals

`mypy_boto3_sagemaker.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from mypy_boto3_sagemaker.literals import (
    ActionStatusType,
    AggregationTransformationValueType,
    AlgorithmSortByType,
    AlgorithmStatusType,
    AppImageConfigSortKeyType,
    AppInstanceTypeType,
    AppNetworkAccessTypeType,
    AppSecurityGroupManagementType,
    AppSortKeyType,
    AppStatusType,
    AppTypeType,
    ArtifactSourceIdTypeType,
    AssemblyTypeType,
    AssociationEdgeTypeType,
    AsyncNotificationTopicTypesType,
    AthenaResultCompressionTypeType,
    AthenaResultFormatType,
    AuthModeType,
    AutoMLAlgorithmType,
    AutoMLChannelTypeType,
    AutoMLJobObjectiveTypeType,
    AutoMLJobSecondaryStatusType,
    AutoMLJobStatusType,
    AutoMLMetricEnumType,
    AutoMLMetricExtendedEnumType,
    AutoMLModeType,
    AutoMLProblemTypeConfigNameType,
    AutoMLProcessingUnitType,
    AutoMLS3DataTypeType,
    AutoMLSortByType,
    AutoMLSortOrderType,
    AutotuneModeType,
    AwsManagedHumanLoopRequestSourceType,
    BatchStrategyType,
    BooleanOperatorType,
    CandidateSortByType,
    CandidateStatusType,
    CandidateStepTypeType,
    CapacitySizeTypeType,
    CaptureModeType,
    CaptureStatusType,
    ClarifyFeatureTypeType,
    ClarifyTextGranularityType,
    ClarifyTextLanguageType,
    CodeRepositorySortByType,
    CodeRepositorySortOrderType,
    CompilationJobStatusType,
    CompleteOnConvergenceType,
    CompressionTypeType,
    ConditionOutcomeType,
    ContainerModeType,
    ContentClassifierType,
    DataDistributionTypeType,
    DetailedAlgorithmStatusType,
    DetailedModelPackageStatusType,
    DeviceDeploymentStatusType,
    DeviceSubsetTypeType,
    DirectInternetAccessType,
    DirectionType,
    DomainStatusType,
    EdgePackagingJobStatusType,
    EdgePresetDeploymentStatusType,
    EdgePresetDeploymentTypeType,
    EndpointConfigSortKeyType,
    EndpointDeletedWaiterName,
    EndpointInServiceWaiterName,
    EndpointSortKeyType,
    EndpointStatusType,
    ExecutionRoleIdentityConfigType,
    ExecutionStatusType,
    FailureHandlingPolicyType,
    FeatureGroupSortByType,
    FeatureGroupSortOrderType,
    FeatureGroupStatusType,
    FeatureStatusType,
    FeatureTypeType,
    FileSystemAccessModeType,
    FileSystemTypeType,
    FillingTypeType,
    FlowDefinitionStatusType,
    FrameworkType,
    HubContentSortByType,
    HubContentStatusType,
    HubContentTypeType,
    HubSortByType,
    HubStatusType,
    HumanTaskUiStatusType,
    HyperParameterScalingTypeType,
    HyperParameterTuningAllocationStrategyType,
    HyperParameterTuningJobObjectiveTypeType,
    HyperParameterTuningJobSortByOptionsType,
    HyperParameterTuningJobStatusType,
    HyperParameterTuningJobStrategyTypeType,
    HyperParameterTuningJobWarmStartTypeType,
    ImageCreatedWaiterName,
    ImageDeletedWaiterName,
    ImageSortByType,
    ImageSortOrderType,
    ImageStatusType,
    ImageUpdatedWaiterName,
    ImageVersionCreatedWaiterName,
    ImageVersionDeletedWaiterName,
    ImageVersionSortByType,
    ImageVersionSortOrderType,
    ImageVersionStatusType,
    InferenceExecutionModeType,
    InferenceExperimentStatusType,
    InferenceExperimentStopDesiredStateType,
    InferenceExperimentTypeType,
    InputModeType,
    InstanceTypeType,
    JobTypeType,
    JoinSourceType,
    LabelingJobStatusType,
    LastUpdateStatusValueType,
    LineageTypeType,
    ListActionsPaginatorName,
    ListAlgorithmsPaginatorName,
    ListAliasesPaginatorName,
    ListAppImageConfigsPaginatorName,
    ListAppsPaginatorName,
    ListArtifactsPaginatorName,
    ListAssociationsPaginatorName,
    ListAutoMLJobsPaginatorName,
    ListCandidatesForAutoMLJobPaginatorName,
    ListCodeRepositoriesPaginatorName,
    ListCompilationJobsPaginatorName,
    ListCompilationJobsSortByType,
    ListContextsPaginatorName,
    ListDataQualityJobDefinitionsPaginatorName,
    ListDeviceFleetsPaginatorName,
    ListDeviceFleetsSortByType,
    ListDevicesPaginatorName,
    ListDomainsPaginatorName,
    ListEdgeDeploymentPlansPaginatorName,
    ListEdgeDeploymentPlansSortByType,
    ListEdgePackagingJobsPaginatorName,
    ListEdgePackagingJobsSortByType,
    ListEndpointConfigsPaginatorName,
    ListEndpointsPaginatorName,
    ListExperimentsPaginatorName,
    ListFeatureGroupsPaginatorName,
    ListFlowDefinitionsPaginatorName,
    ListHumanTaskUisPaginatorName,
    ListHyperParameterTuningJobsPaginatorName,
    ListImageVersionsPaginatorName,
    ListImagesPaginatorName,
    ListInferenceExperimentsPaginatorName,
    ListInferenceRecommendationsJobStepsPaginatorName,
    ListInferenceRecommendationsJobsPaginatorName,
    ListInferenceRecommendationsJobsSortByType,
    ListLabelingJobsForWorkteamPaginatorName,
    ListLabelingJobsForWorkteamSortByOptionsType,
    ListLabelingJobsPaginatorName,
    ListLineageGroupsPaginatorName,
    ListModelBiasJobDefinitionsPaginatorName,
    ListModelCardExportJobsPaginatorName,
    ListModelCardVersionsPaginatorName,
    ListModelCardsPaginatorName,
    ListModelExplainabilityJobDefinitionsPaginatorName,
    ListModelMetadataPaginatorName,
    ListModelPackageGroupsPaginatorName,
    ListModelPackagesPaginatorName,
    ListModelQualityJobDefinitionsPaginatorName,
    ListModelsPaginatorName,
    ListMonitoringAlertHistoryPaginatorName,
    ListMonitoringAlertsPaginatorName,
    ListMonitoringExecutionsPaginatorName,
    ListMonitoringSchedulesPaginatorName,
    ListNotebookInstanceLifecycleConfigsPaginatorName,
    ListNotebookInstancesPaginatorName,
    ListPipelineExecutionStepsPaginatorName,
    ListPipelineExecutionsPaginatorName,
    ListPipelineParametersForExecutionPaginatorName,
    ListPipelinesPaginatorName,
    ListProcessingJobsPaginatorName,
    ListSpacesPaginatorName,
    ListStageDevicesPaginatorName,
    ListStudioLifecycleConfigsPaginatorName,
    ListSubscribedWorkteamsPaginatorName,
    ListTagsPaginatorName,
    ListTrainingJobsForHyperParameterTuningJobPaginatorName,
    ListTrainingJobsPaginatorName,
    ListTransformJobsPaginatorName,
    ListTrialComponentsPaginatorName,
    ListTrialsPaginatorName,
    ListUserProfilesPaginatorName,
    ListWorkforcesPaginatorName,
    ListWorkforcesSortByOptionsType,
    ListWorkteamsPaginatorName,
    ListWorkteamsSortByOptionsType,
    MetricSetSourceType,
    ModelApprovalStatusType,
    ModelCacheSettingType,
    ModelCardExportJobSortByType,
    ModelCardExportJobSortOrderType,
    ModelCardExportJobStatusType,
    ModelCardProcessingStatusType,
    ModelCardSortByType,
    ModelCardSortOrderType,
    ModelCardStatusType,
    ModelCardVersionSortByType,
    ModelCompressionTypeType,
    ModelInfrastructureTypeType,
    ModelMetadataFilterTypeType,
    ModelPackageGroupSortByType,
    ModelPackageGroupStatusType,
    ModelPackageSortByType,
    ModelPackageStatusType,
    ModelPackageTypeType,
    ModelSortKeyType,
    ModelVariantActionType,
    ModelVariantStatusType,
    MonitoringAlertHistorySortKeyType,
    MonitoringAlertStatusType,
    MonitoringExecutionSortKeyType,
    MonitoringJobDefinitionSortKeyType,
    MonitoringProblemTypeType,
    MonitoringScheduleSortKeyType,
    MonitoringTypeType,
    NotebookInstanceAcceleratorTypeType,
    NotebookInstanceDeletedWaiterName,
    NotebookInstanceInServiceWaiterName,
    NotebookInstanceLifecycleConfigSortKeyType,
    NotebookInstanceLifecycleConfigSortOrderType,
    NotebookInstanceSortKeyType,
    NotebookInstanceSortOrderType,
    NotebookInstanceStatusType,
    NotebookInstanceStoppedWaiterName,
    NotebookOutputOptionType,
    ObjectiveStatusType,
    OfflineStoreStatusValueType,
    OperatorType,
    OrderKeyType,
    OutputCompressionTypeType,
    ParameterTypeType,
    PipelineExecutionStatusType,
    PipelineStatusType,
    ProblemTypeType,
    ProcessingInstanceTypeType,
    ProcessingJobCompletedOrStoppedWaiterName,
    ProcessingJobStatusType,
    ProcessingS3CompressionTypeType,
    ProcessingS3DataDistributionTypeType,
    ProcessingS3DataTypeType,
    ProcessingS3InputModeType,
    ProcessingS3UploadModeType,
    ProcessorType,
    ProductionVariantAcceleratorTypeType,
    ProductionVariantInstanceTypeType,
    ProfilingStatusType,
    ProjectSortByType,
    ProjectSortOrderType,
    ProjectStatusType,
    RStudioServerProAccessStatusType,
    RStudioServerProUserGroupType,
    RecommendationJobStatusType,
    RecommendationJobSupportedEndpointTypeType,
    RecommendationJobTypeType,
    RecommendationStatusType,
    RecommendationStepTypeType,
    RecordWrapperType,
    RedshiftResultCompressionTypeType,
    RedshiftResultFormatType,
    RepositoryAccessModeType,
    ResourceTypeType,
    RetentionTypeType,
    RootAccessType,
    RuleEvaluationStatusType,
    S3DataDistributionType,
    S3DataTypeType,
    S3ModelDataTypeType,
    SagemakerServicecatalogStatusType,
    ScheduleStatusType,
    SearchPaginatorName,
    SearchSortOrderType,
    SecondaryStatusType,
    SortActionsByType,
    SortArtifactsByType,
    SortAssociationsByType,
    SortByType,
    SortContextsByType,
    SortExperimentsByType,
    SortInferenceExperimentsByType,
    SortLineageGroupsByType,
    SortOrderType,
    SortPipelineExecutionsByType,
    SortPipelinesByType,
    SortTrialComponentsByType,
    SortTrialsByType,
    SpaceSortKeyType,
    SpaceStatusType,
    SplitTypeType,
    StageStatusType,
    StepStatusType,
    StudioLifecycleConfigAppTypeType,
    StudioLifecycleConfigSortKeyType,
    TableFormatType,
    TargetDeviceType,
    TargetPlatformAcceleratorType,
    TargetPlatformArchType,
    TargetPlatformOsType,
    TrafficRoutingConfigTypeType,
    TrafficTypeType,
    TrainingInputModeType,
    TrainingInstanceTypeType,
    TrainingJobCompletedOrStoppedWaiterName,
    TrainingJobEarlyStoppingTypeType,
    TrainingJobSortByOptionsType,
    TrainingJobStatusType,
    TrainingRepositoryAccessModeType,
    TransformInstanceTypeType,
    TransformJobCompletedOrStoppedWaiterName,
    TransformJobStatusType,
    TrialComponentPrimaryStatusType,
    TtlDurationUnitType,
    UserProfileSortKeyType,
    UserProfileStatusType,
    VariantPropertyTypeType,
    VariantStatusType,
    VendorGuidanceType,
    WarmPoolResourceStatusType,
    WorkforceStatusType,
    SageMakerServiceName,
    ServiceName,
    ResourceServiceName,
    PaginatorName,
    WaiterName,
    RegionName,
)


def check_value(value: ActionStatusType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_sagemaker.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_sagemaker.type_defs import (
    ActionSourceOutputTypeDef,
    ActionSourceTypeDef,
    AddAssociationRequestRequestTypeDef,
    AddAssociationResponseOutputTypeDef,
    TagTypeDef,
    TagOutputTypeDef,
    AgentVersionOutputTypeDef,
    AlarmOutputTypeDef,
    AlarmTypeDef,
    MetricDefinitionOutputTypeDef,
    MetricDefinitionTypeDef,
    AlgorithmStatusItemOutputTypeDef,
    AlgorithmSummaryOutputTypeDef,
    AnnotationConsolidationConfigOutputTypeDef,
    AnnotationConsolidationConfigTypeDef,
    AppDetailsOutputTypeDef,
    AppSpecificationOutputTypeDef,
    AppSpecificationTypeDef,
    ArtifactSourceTypeOutputTypeDef,
    ArtifactSourceTypeTypeDef,
    AssociateTrialComponentRequestRequestTypeDef,
    AssociateTrialComponentResponseOutputTypeDef,
    AsyncInferenceClientConfigOutputTypeDef,
    AsyncInferenceClientConfigTypeDef,
    AsyncInferenceNotificationConfigOutputTypeDef,
    AsyncInferenceNotificationConfigTypeDef,
    AthenaDatasetDefinitionOutputTypeDef,
    AthenaDatasetDefinitionTypeDef,
    AutoMLAlgorithmConfigOutputTypeDef,
    AutoMLAlgorithmConfigTypeDef,
    AutoMLCandidateStepOutputTypeDef,
    AutoMLContainerDefinitionOutputTypeDef,
    FinalAutoMLJobObjectiveMetricOutputTypeDef,
    AutoMLS3DataSourceOutputTypeDef,
    AutoMLS3DataSourceTypeDef,
    AutoMLDataSplitConfigOutputTypeDef,
    AutoMLDataSplitConfigTypeDef,
    AutoMLJobArtifactsOutputTypeDef,
    AutoMLJobCompletionCriteriaOutputTypeDef,
    AutoMLJobCompletionCriteriaTypeDef,
    AutoMLJobObjectiveOutputTypeDef,
    AutoMLJobObjectiveTypeDef,
    AutoMLJobStepMetadataOutputTypeDef,
    AutoMLPartialFailureReasonOutputTypeDef,
    AutoMLOutputDataConfigOutputTypeDef,
    AutoMLOutputDataConfigTypeDef,
    TabularResolvedAttributesOutputTypeDef,
    VpcConfigOutputTypeDef,
    VpcConfigTypeDef,
    AutoParameterOutputTypeDef,
    AutoParameterTypeDef,
    AutotuneOutputTypeDef,
    AutotuneTypeDef,
    BatchDataCaptureConfigOutputTypeDef,
    BatchDataCaptureConfigTypeDef,
    BatchDescribeModelPackageErrorOutputTypeDef,
    BatchDescribeModelPackageInputRequestTypeDef,
    BestObjectiveNotImprovingOutputTypeDef,
    BestObjectiveNotImprovingTypeDef,
    MetricsSourceOutputTypeDef,
    MetricsSourceTypeDef,
    CacheHitResultOutputTypeDef,
    OutputParameterOutputTypeDef,
    CandidateArtifactLocationsOutputTypeDef,
    MetricDatumOutputTypeDef,
    ModelRegisterSettingsOutputTypeDef,
    TimeSeriesForecastingSettingsOutputTypeDef,
    WorkspaceSettingsOutputTypeDef,
    ModelRegisterSettingsTypeDef,
    TimeSeriesForecastingSettingsTypeDef,
    WorkspaceSettingsTypeDef,
    CapacitySizeOutputTypeDef,
    CapacitySizeTypeDef,
    CaptureContentTypeHeaderOutputTypeDef,
    CaptureContentTypeHeaderTypeDef,
    CaptureOptionOutputTypeDef,
    CaptureOptionTypeDef,
    CategoricalParameterOutputTypeDef,
    CategoricalParameterRangeOutputTypeDef,
    CategoricalParameterRangeSpecificationOutputTypeDef,
    CategoricalParameterRangeSpecificationTypeDef,
    CategoricalParameterRangeTypeDef,
    CategoricalParameterTypeDef,
    ShuffleConfigOutputTypeDef,
    ChannelSpecificationOutputTypeDef,
    ChannelSpecificationTypeDef,
    ShuffleConfigTypeDef,
    CheckpointConfigOutputTypeDef,
    CheckpointConfigTypeDef,
    ClarifyCheckStepMetadataOutputTypeDef,
    ClarifyInferenceConfigOutputTypeDef,
    ClarifyInferenceConfigTypeDef,
    ClarifyShapBaselineConfigOutputTypeDef,
    ClarifyShapBaselineConfigTypeDef,
    ClarifyTextConfigOutputTypeDef,
    ClarifyTextConfigTypeDef,
    CodeRepositoryOutputTypeDef,
    GitConfigOutputTypeDef,
    CodeRepositoryTypeDef,
    CognitoConfigOutputTypeDef,
    CognitoConfigTypeDef,
    CognitoMemberDefinitionOutputTypeDef,
    CognitoMemberDefinitionTypeDef,
    CollectionConfigurationOutputTypeDef,
    CollectionConfigurationTypeDef,
    CompilationJobSummaryOutputTypeDef,
    ConditionStepMetadataOutputTypeDef,
    MultiModelConfigOutputTypeDef,
    MultiModelConfigTypeDef,
    ContextSourceOutputTypeDef,
    ContextSourceTypeDef,
    ContinuousParameterRangeOutputTypeDef,
    ContinuousParameterRangeSpecificationOutputTypeDef,
    ContinuousParameterRangeSpecificationTypeDef,
    ContinuousParameterRangeTypeDef,
    ConvergenceDetectedOutputTypeDef,
    ConvergenceDetectedTypeDef,
    MetadataPropertiesTypeDef,
    CreateActionResponseOutputTypeDef,
    CreateAlgorithmOutputOutputTypeDef,
    CreateAppImageConfigResponseOutputTypeDef,
    ResourceSpecTypeDef,
    CreateAppResponseOutputTypeDef,
    CreateArtifactResponseOutputTypeDef,
    ModelDeployConfigTypeDef,
    CreateAutoMLJobResponseOutputTypeDef,
    CreateAutoMLJobV2ResponseOutputTypeDef,
    GitConfigTypeDef,
    CreateCodeRepositoryOutputOutputTypeDef,
    InputConfigTypeDef,
    NeoVpcConfigTypeDef,
    StoppingConditionTypeDef,
    CreateCompilationJobResponseOutputTypeDef,
    CreateContextResponseOutputTypeDef,
    DataQualityAppSpecificationTypeDef,
    MonitoringStoppingConditionTypeDef,
    CreateDataQualityJobDefinitionResponseOutputTypeDef,
    EdgeOutputConfigTypeDef,
    CreateDomainResponseOutputTypeDef,
    EdgeDeploymentModelConfigTypeDef,
    CreateEdgeDeploymentPlanResponseOutputTypeDef,
    CreateEndpointConfigOutputOutputTypeDef,
    CreateEndpointOutputOutputTypeDef,
    CreateExperimentResponseOutputTypeDef,
    FeatureDefinitionTypeDef,
    CreateFeatureGroupResponseOutputTypeDef,
    FlowDefinitionOutputConfigTypeDef,
    HumanLoopRequestSourceTypeDef,
    CreateFlowDefinitionResponseOutputTypeDef,
    HubS3StorageConfigTypeDef,
    CreateHubResponseOutputTypeDef,
    UiTemplateTypeDef,
    CreateHumanTaskUiResponseOutputTypeDef,
    CreateHyperParameterTuningJobResponseOutputTypeDef,
    CreateImageResponseOutputTypeDef,
    CreateImageVersionRequestRequestTypeDef,
    CreateImageVersionResponseOutputTypeDef,
    InferenceExperimentScheduleTypeDef,
    CreateInferenceExperimentResponseOutputTypeDef,
    CreateInferenceRecommendationsJobResponseOutputTypeDef,
    LabelingJobOutputConfigTypeDef,
    LabelingJobStoppingConditionsTypeDef,
    CreateLabelingJobResponseOutputTypeDef,
    ModelBiasAppSpecificationTypeDef,
    CreateModelBiasJobDefinitionResponseOutputTypeDef,
    ModelCardExportOutputConfigTypeDef,
    CreateModelCardExportJobResponseOutputTypeDef,
    ModelCardSecurityConfigTypeDef,
    CreateModelCardResponseOutputTypeDef,
    ModelExplainabilityAppSpecificationTypeDef,
    CreateModelExplainabilityJobDefinitionResponseOutputTypeDef,
    InferenceExecutionConfigTypeDef,
    CreateModelOutputOutputTypeDef,
    CreateModelPackageGroupOutputOutputTypeDef,
    CreateModelPackageOutputOutputTypeDef,
    ModelQualityAppSpecificationTypeDef,
    CreateModelQualityJobDefinitionResponseOutputTypeDef,
    CreateMonitoringScheduleResponseOutputTypeDef,
    InstanceMetadataServiceConfigurationTypeDef,
    NotebookInstanceLifecycleHookTypeDef,
    CreateNotebookInstanceLifecycleConfigOutputOutputTypeDef,
    CreateNotebookInstanceOutputOutputTypeDef,
    ParallelismConfigurationTypeDef,
    PipelineDefinitionS3LocationTypeDef,
    CreatePipelineResponseOutputTypeDef,
    CreatePresignedDomainUrlRequestRequestTypeDef,
    CreatePresignedDomainUrlResponseOutputTypeDef,
    CreatePresignedNotebookInstanceUrlInputRequestTypeDef,
    CreatePresignedNotebookInstanceUrlOutputOutputTypeDef,
    ExperimentConfigTypeDef,
    ProcessingStoppingConditionTypeDef,
    CreateProcessingJobResponseOutputTypeDef,
    CreateProjectOutputOutputTypeDef,
    CreateSpaceResponseOutputTypeDef,
    CreateStudioLifecycleConfigResponseOutputTypeDef,
    DebugRuleConfigurationTypeDef,
    OutputDataConfigTypeDef,
    ProfilerConfigTypeDef,
    ProfilerRuleConfigurationTypeDef,
    RetryStrategyTypeDef,
    TensorBoardOutputConfigTypeDef,
    CreateTrainingJobResponseOutputTypeDef,
    DataProcessingTypeDef,
    ModelClientConfigTypeDef,
    TransformOutputTypeDef,
    TransformResourcesTypeDef,
    CreateTransformJobResponseOutputTypeDef,
    TrialComponentArtifactTypeDef,
    TrialComponentParameterValueTypeDef,
    TrialComponentStatusTypeDef,
    CreateTrialComponentResponseOutputTypeDef,
    CreateTrialResponseOutputTypeDef,
    CreateUserProfileResponseOutputTypeDef,
    OidcConfigTypeDef,
    SourceIpConfigTypeDef,
    WorkforceVpcConfigRequestTypeDef,
    CreateWorkforceResponseOutputTypeDef,
    NotificationConfigurationTypeDef,
    CreateWorkteamResponseOutputTypeDef,
    CustomImageOutputTypeDef,
    CustomImageTypeDef,
    DataCaptureConfigSummaryOutputTypeDef,
    DataCatalogConfigOutputTypeDef,
    DataCatalogConfigTypeDef,
    DataProcessingOutputTypeDef,
    DataQualityAppSpecificationOutputTypeDef,
    MonitoringConstraintsResourceOutputTypeDef,
    MonitoringStatisticsResourceOutputTypeDef,
    MonitoringConstraintsResourceTypeDef,
    MonitoringStatisticsResourceTypeDef,
    EndpointInputOutputTypeDef,
    EndpointInputTypeDef,
    FileSystemDataSourceOutputTypeDef,
    S3DataSourceOutputTypeDef,
    FileSystemDataSourceTypeDef,
    S3DataSourceTypeDef,
    RedshiftDatasetDefinitionOutputTypeDef,
    RedshiftDatasetDefinitionTypeDef,
    DebugRuleConfigurationOutputTypeDef,
    DebugRuleEvaluationStatusOutputTypeDef,
    DeleteActionRequestRequestTypeDef,
    DeleteActionResponseOutputTypeDef,
    DeleteAlgorithmInputRequestTypeDef,
    DeleteAppImageConfigRequestRequestTypeDef,
    DeleteAppRequestRequestTypeDef,
    DeleteArtifactResponseOutputTypeDef,
    DeleteAssociationRequestRequestTypeDef,
    DeleteAssociationResponseOutputTypeDef,
    DeleteCodeRepositoryInputRequestTypeDef,
    DeleteContextRequestRequestTypeDef,
    DeleteContextResponseOutputTypeDef,
    DeleteDataQualityJobDefinitionRequestRequestTypeDef,
    DeleteDeviceFleetRequestRequestTypeDef,
    RetentionPolicyTypeDef,
    DeleteEdgeDeploymentPlanRequestRequestTypeDef,
    DeleteEdgeDeploymentStageRequestRequestTypeDef,
    DeleteEndpointConfigInputRequestTypeDef,
    DeleteEndpointInputRequestTypeDef,
    DeleteExperimentRequestRequestTypeDef,
    DeleteExperimentResponseOutputTypeDef,
    DeleteFeatureGroupRequestRequestTypeDef,
    DeleteFlowDefinitionRequestRequestTypeDef,
    DeleteHubContentRequestRequestTypeDef,
    DeleteHubRequestRequestTypeDef,
    DeleteHumanTaskUiRequestRequestTypeDef,
    DeleteImageRequestRequestTypeDef,
    DeleteImageVersionRequestRequestTypeDef,
    DeleteInferenceExperimentRequestRequestTypeDef,
    DeleteInferenceExperimentResponseOutputTypeDef,
    DeleteModelBiasJobDefinitionRequestRequestTypeDef,
    DeleteModelCardRequestRequestTypeDef,
    DeleteModelExplainabilityJobDefinitionRequestRequestTypeDef,
    DeleteModelInputRequestTypeDef,
    DeleteModelPackageGroupInputRequestTypeDef,
    DeleteModelPackageGroupPolicyInputRequestTypeDef,
    DeleteModelPackageInputRequestTypeDef,
    DeleteModelQualityJobDefinitionRequestRequestTypeDef,
    DeleteMonitoringScheduleRequestRequestTypeDef,
    DeleteNotebookInstanceInputRequestTypeDef,
    DeleteNotebookInstanceLifecycleConfigInputRequestTypeDef,
    DeletePipelineRequestRequestTypeDef,
    DeletePipelineResponseOutputTypeDef,
    DeleteProjectInputRequestTypeDef,
    DeleteSpaceRequestRequestTypeDef,
    DeleteStudioLifecycleConfigRequestRequestTypeDef,
    DeleteTagsInputRequestTypeDef,
    DeleteTrialComponentRequestRequestTypeDef,
    DeleteTrialComponentResponseOutputTypeDef,
    DeleteTrialRequestRequestTypeDef,
    DeleteTrialResponseOutputTypeDef,
    DeleteUserProfileRequestRequestTypeDef,
    DeleteWorkforceRequestRequestTypeDef,
    DeleteWorkteamRequestRequestTypeDef,
    DeleteWorkteamResponseOutputTypeDef,
    DeployedImageOutputTypeDef,
    RealTimeInferenceRecommendationOutputTypeDef,
    DeviceSelectionConfigOutputTypeDef,
    EdgeDeploymentConfigOutputTypeDef,
    EdgeDeploymentStatusOutputTypeDef,
    DeviceSelectionConfigTypeDef,
    EdgeDeploymentConfigTypeDef,
    DeregisterDevicesRequestRequestTypeDef,
    DescribeActionRequestRequestTypeDef,
    MetadataPropertiesOutputTypeDef,
    DescribeAlgorithmInputRequestTypeDef,
    DescribeAppImageConfigRequestRequestTypeDef,
    DescribeAppRequestRequestTypeDef,
    ResourceSpecOutputTypeDef,
    DescribeArtifactRequestRequestTypeDef,
    DescribeAutoMLJobRequestRequestTypeDef,
    ModelDeployConfigOutputTypeDef,
    ModelDeployResultOutputTypeDef,
    DescribeAutoMLJobV2RequestRequestTypeDef,
    DescribeCodeRepositoryInputRequestTypeDef,
    DescribeCompilationJobRequestRequestTypeDef,
    InputConfigOutputTypeDef,
    ModelArtifactsOutputTypeDef,
    ModelDigestsOutputTypeDef,
    NeoVpcConfigOutputTypeDef,
    StoppingConditionOutputTypeDef,
    DescribeContextRequestRequestTypeDef,
    DescribeDataQualityJobDefinitionRequestRequestTypeDef,
    MonitoringStoppingConditionOutputTypeDef,
    DescribeDeviceFleetRequestRequestTypeDef,
    EdgeOutputConfigOutputTypeDef,
    DescribeDeviceRequestRequestTypeDef,
    EdgeModelOutputTypeDef,
    DescribeDomainRequestRequestTypeDef,
    DescribeEdgeDeploymentPlanRequestRequestTypeDef,
    EdgeDeploymentModelConfigOutputTypeDef,
    DescribeEdgePackagingJobRequestRequestTypeDef,
    EdgePresetDeploymentOutputOutputTypeDef,
    DescribeEndpointConfigInputRequestTypeDef,
    WaiterConfigTypeDef,
    DescribeEndpointInputRequestTypeDef,
    DescribeExperimentRequestRequestTypeDef,
    ExperimentSourceOutputTypeDef,
    DescribeFeatureGroupRequestRequestTypeDef,
    FeatureDefinitionOutputTypeDef,
    LastUpdateStatusOutputTypeDef,
    OfflineStoreStatusOutputTypeDef,
    DescribeFeatureMetadataRequestRequestTypeDef,
    FeatureParameterOutputTypeDef,
    DescribeFlowDefinitionRequestRequestTypeDef,
    FlowDefinitionOutputConfigOutputTypeDef,
    HumanLoopRequestSourceOutputTypeDef,
    DescribeHubContentRequestRequestTypeDef,
    HubContentDependencyOutputTypeDef,
    DescribeHubRequestRequestTypeDef,
    HubS3StorageConfigOutputTypeDef,
    DescribeHumanTaskUiRequestRequestTypeDef,
    UiTemplateInfoOutputTypeDef,
    DescribeHyperParameterTuningJobRequestRequestTypeDef,
    HyperParameterTuningJobCompletionDetailsOutputTypeDef,
    HyperParameterTuningJobConsumedResourcesOutputTypeDef,
    ObjectiveStatusCountersOutputTypeDef,
    TrainingJobStatusCountersOutputTypeDef,
    DescribeImageRequestRequestTypeDef,
    DescribeImageResponseOutputTypeDef,
    DescribeImageVersionRequestRequestTypeDef,
    DescribeImageVersionResponseOutputTypeDef,
    DescribeInferenceExperimentRequestRequestTypeDef,
    EndpointMetadataOutputTypeDef,
    InferenceExperimentScheduleOutputTypeDef,
    DescribeInferenceRecommendationsJobRequestRequestTypeDef,
    DescribeLabelingJobRequestRequestTypeDef,
    LabelCountersOutputTypeDef,
    LabelingJobOutputConfigOutputTypeDef,
    LabelingJobOutputOutputTypeDef,
    LabelingJobStoppingConditionsOutputTypeDef,
    DescribeLineageGroupRequestRequestTypeDef,
    DescribeModelBiasJobDefinitionRequestRequestTypeDef,
    ModelBiasAppSpecificationOutputTypeDef,
    DescribeModelCardExportJobRequestRequestTypeDef,
    ModelCardExportArtifactsOutputTypeDef,
    ModelCardExportOutputConfigOutputTypeDef,
    DescribeModelCardRequestRequestTypeDef,
    ModelCardSecurityConfigOutputTypeDef,
    DescribeModelExplainabilityJobDefinitionRequestRequestTypeDef,
    ModelExplainabilityAppSpecificationOutputTypeDef,
    DescribeModelInputRequestTypeDef,
    InferenceExecutionConfigOutputTypeDef,
    DescribeModelPackageGroupInputRequestTypeDef,
    DescribeModelPackageInputRequestTypeDef,
    DescribeModelQualityJobDefinitionRequestRequestTypeDef,
    ModelQualityAppSpecificationOutputTypeDef,
    DescribeMonitoringScheduleRequestRequestTypeDef,
    MonitoringExecutionSummaryOutputTypeDef,
    DescribeNotebookInstanceInputRequestTypeDef,
    DescribeNotebookInstanceLifecycleConfigInputRequestTypeDef,
    NotebookInstanceLifecycleHookOutputTypeDef,
    InstanceMetadataServiceConfigurationOutputTypeDef,
    DescribePipelineDefinitionForExecutionRequestRequestTypeDef,
    DescribePipelineDefinitionForExecutionResponseOutputTypeDef,
    DescribePipelineExecutionRequestRequestTypeDef,
    ParallelismConfigurationOutputTypeDef,
    PipelineExperimentConfigOutputTypeDef,
    DescribePipelineRequestRequestTypeDef,
    DescribeProcessingJobRequestRequestTypeDef,
    ExperimentConfigOutputTypeDef,
    ProcessingStoppingConditionOutputTypeDef,
    DescribeProjectInputRequestTypeDef,
    ServiceCatalogProvisionedProductDetailsOutputTypeDef,
    DescribeSpaceRequestRequestTypeDef,
    DescribeStudioLifecycleConfigRequestRequestTypeDef,
    DescribeStudioLifecycleConfigResponseOutputTypeDef,
    DescribeSubscribedWorkteamRequestRequestTypeDef,
    SubscribedWorkteamOutputTypeDef,
    DescribeTrainingJobRequestRequestTypeDef,
    MetricDataOutputTypeDef,
    OutputDataConfigOutputTypeDef,
    ProfilerConfigOutputTypeDef,
    ProfilerRuleConfigurationOutputTypeDef,
    ProfilerRuleEvaluationStatusOutputTypeDef,
    RetryStrategyOutputTypeDef,
    SecondaryStatusTransitionOutputTypeDef,
    TensorBoardOutputConfigOutputTypeDef,
    WarmPoolStatusOutputTypeDef,
    DescribeTransformJobRequestRequestTypeDef,
    ModelClientConfigOutputTypeDef,
    TransformOutputOutputTypeDef,
    TransformResourcesOutputTypeDef,
    DescribeTrialComponentRequestRequestTypeDef,
    TrialComponentArtifactOutputTypeDef,
    TrialComponentMetricSummaryOutputTypeDef,
    TrialComponentParameterValueOutputTypeDef,
    TrialComponentSourceOutputTypeDef,
    TrialComponentStatusOutputTypeDef,
    DescribeTrialRequestRequestTypeDef,
    TrialSourceOutputTypeDef,
    DescribeUserProfileRequestRequestTypeDef,
    DescribeWorkforceRequestRequestTypeDef,
    DescribeWorkteamRequestRequestTypeDef,
    ProductionVariantServerlessUpdateConfigTypeDef,
    DeviceDeploymentSummaryOutputTypeDef,
    DeviceFleetSummaryOutputTypeDef,
    DeviceStatsOutputTypeDef,
    EdgeModelSummaryOutputTypeDef,
    DeviceTypeDef,
    DisassociateTrialComponentRequestRequestTypeDef,
    DisassociateTrialComponentResponseOutputTypeDef,
    DomainDetailsOutputTypeDef,
    FileSourceOutputTypeDef,
    FileSourceTypeDef,
    EMRStepMetadataOutputTypeDef,
    EdgeDeploymentPlanSummaryOutputTypeDef,
    EdgeModelStatOutputTypeDef,
    EdgeOutputTypeDef,
    EdgePackagingJobSummaryOutputTypeDef,
    EmptyResponseMetadataTypeDef,
    EndpointConfigSummaryOutputTypeDef,
    EndpointInfoOutputTypeDef,
    EndpointInfoTypeDef,
    ProductionVariantServerlessConfigOutputTypeDef,
    ProductionVariantServerlessConfigTypeDef,
    InferenceMetricsOutputTypeDef,
    EndpointSummaryOutputTypeDef,
    EnvironmentParameterOutputTypeDef,
    FailStepMetadataOutputTypeDef,
    FeatureParameterTypeDef,
    FileSystemConfigOutputTypeDef,
    FileSystemConfigTypeDef,
    FilterTypeDef,
    FinalHyperParameterTuningJobObjectiveMetricOutputTypeDef,
    FlowDefinitionSummaryOutputTypeDef,
    GetDeviceFleetReportRequestRequestTypeDef,
    GetLineageGroupPolicyRequestRequestTypeDef,
    GetLineageGroupPolicyResponseOutputTypeDef,
    GetModelPackageGroupPolicyInputRequestTypeDef,
    GetModelPackageGroupPolicyOutputOutputTypeDef,
    GetSagemakerServicecatalogPortfolioStatusOutputOutputTypeDef,
    PropertyNameSuggestionOutputTypeDef,
    GitConfigForUpdateTypeDef,
    HubContentInfoOutputTypeDef,
    HubInfoOutputTypeDef,
    HumanLoopActivationConditionsConfigOutputTypeDef,
    HumanLoopActivationConditionsConfigTypeDef,
    UiConfigOutputTypeDef,
    UiConfigTypeDef,
    HumanTaskUiSummaryOutputTypeDef,
    HyperParameterTuningJobObjectiveOutputTypeDef,
    HyperParameterTuningJobObjectiveTypeDef,
    HyperParameterTuningInstanceConfigOutputTypeDef,
    HyperParameterTuningInstanceConfigTypeDef,
    ResourceLimitsOutputTypeDef,
    ResourceLimitsTypeDef,
    HyperbandStrategyConfigOutputTypeDef,
    HyperbandStrategyConfigTypeDef,
    ParentHyperParameterTuningJobOutputTypeDef,
    ParentHyperParameterTuningJobTypeDef,
    IamIdentityOutputTypeDef,
    RepositoryAuthConfigOutputTypeDef,
    RepositoryAuthConfigTypeDef,
    ImageOutputTypeDef,
    ImageVersionOutputTypeDef,
    ImportHubContentResponseOutputTypeDef,
    RecommendationMetricsOutputTypeDef,
    InferenceRecommendationsJobOutputTypeDef,
    InstanceGroupOutputTypeDef,
    InstanceGroupTypeDef,
    IntegerParameterRangeOutputTypeDef,
    IntegerParameterRangeSpecificationOutputTypeDef,
    IntegerParameterRangeSpecificationTypeDef,
    IntegerParameterRangeTypeDef,
    KernelSpecOutputTypeDef,
    KernelSpecTypeDef,
    LabelCountersForWorkteamOutputTypeDef,
    LabelingJobDataAttributesOutputTypeDef,
    LabelingJobDataAttributesTypeDef,
    LabelingJobS3DataSourceOutputTypeDef,
    LabelingJobSnsDataSourceOutputTypeDef,
    LabelingJobS3DataSourceTypeDef,
    LabelingJobSnsDataSourceTypeDef,
    LineageGroupSummaryOutputTypeDef,
    ListActionsRequestListActionsPaginateTypeDef,
    ListActionsRequestRequestTypeDef,
    ListAlgorithmsInputListAlgorithmsPaginateTypeDef,
    ListAlgorithmsInputRequestTypeDef,
    ListAliasesRequestListAliasesPaginateTypeDef,
    ListAliasesRequestRequestTypeDef,
    ListAliasesResponseOutputTypeDef,
    ListAppImageConfigsRequestListAppImageConfigsPaginateTypeDef,
    ListAppImageConfigsRequestRequestTypeDef,
    ListAppsRequestListAppsPaginateTypeDef,
    ListAppsRequestRequestTypeDef,
    ListArtifactsRequestListArtifactsPaginateTypeDef,
    ListArtifactsRequestRequestTypeDef,
    ListAssociationsRequestListAssociationsPaginateTypeDef,
    ListAssociationsRequestRequestTypeDef,
    ListAutoMLJobsRequestListAutoMLJobsPaginateTypeDef,
    ListAutoMLJobsRequestRequestTypeDef,
    ListCandidatesForAutoMLJobRequestListCandidatesForAutoMLJobPaginateTypeDef,
    ListCandidatesForAutoMLJobRequestRequestTypeDef,
    ListCodeRepositoriesInputListCodeRepositoriesPaginateTypeDef,
    ListCodeRepositoriesInputRequestTypeDef,
    ListCompilationJobsRequestListCompilationJobsPaginateTypeDef,
    ListCompilationJobsRequestRequestTypeDef,
    ListContextsRequestListContextsPaginateTypeDef,
    ListContextsRequestRequestTypeDef,
    ListDataQualityJobDefinitionsRequestListDataQualityJobDefinitionsPaginateTypeDef,
    ListDataQualityJobDefinitionsRequestRequestTypeDef,
    MonitoringJobDefinitionSummaryOutputTypeDef,
    ListDeviceFleetsRequestListDeviceFleetsPaginateTypeDef,
    ListDeviceFleetsRequestRequestTypeDef,
    ListDevicesRequestListDevicesPaginateTypeDef,
    ListDevicesRequestRequestTypeDef,
    ListDomainsRequestListDomainsPaginateTypeDef,
    ListDomainsRequestRequestTypeDef,
    ListEdgeDeploymentPlansRequestListEdgeDeploymentPlansPaginateTypeDef,
    ListEdgeDeploymentPlansRequestRequestTypeDef,
    ListEdgePackagingJobsRequestListEdgePackagingJobsPaginateTypeDef,
    ListEdgePackagingJobsRequestRequestTypeDef,
    ListEndpointConfigsInputListEndpointConfigsPaginateTypeDef,
    ListEndpointConfigsInputRequestTypeDef,
    ListEndpointsInputListEndpointsPaginateTypeDef,
    ListEndpointsInputRequestTypeDef,
    ListExperimentsRequestListExperimentsPaginateTypeDef,
    ListExperimentsRequestRequestTypeDef,
    ListFeatureGroupsRequestListFeatureGroupsPaginateTypeDef,
    ListFeatureGroupsRequestRequestTypeDef,
    ListFlowDefinitionsRequestListFlowDefinitionsPaginateTypeDef,
    ListFlowDefinitionsRequestRequestTypeDef,
    ListHubContentVersionsRequestRequestTypeDef,
    ListHubContentsRequestRequestTypeDef,
    ListHubsRequestRequestTypeDef,
    ListHumanTaskUisRequestListHumanTaskUisPaginateTypeDef,
    ListHumanTaskUisRequestRequestTypeDef,
    ListHyperParameterTuningJobsRequestListHyperParameterTuningJobsPaginateTypeDef,
    ListHyperParameterTuningJobsRequestRequestTypeDef,
    ListImageVersionsRequestListImageVersionsPaginateTypeDef,
    ListImageVersionsRequestRequestTypeDef,
    ListImagesRequestListImagesPaginateTypeDef,
    ListImagesRequestRequestTypeDef,
    ListInferenceExperimentsRequestListInferenceExperimentsPaginateTypeDef,
    ListInferenceExperimentsRequestRequestTypeDef,
    ListInferenceRecommendationsJobStepsRequestListInferenceRecommendationsJobStepsPaginateTypeDef,
    ListInferenceRecommendationsJobStepsRequestRequestTypeDef,
    ListInferenceRecommendationsJobsRequestListInferenceRecommendationsJobsPaginateTypeDef,
    ListInferenceRecommendationsJobsRequestRequestTypeDef,
    ListLabelingJobsForWorkteamRequestListLabelingJobsForWorkteamPaginateTypeDef,
    ListLabelingJobsForWorkteamRequestRequestTypeDef,
    ListLabelingJobsRequestListLabelingJobsPaginateTypeDef,
    ListLabelingJobsRequestRequestTypeDef,
    ListLineageGroupsRequestListLineageGroupsPaginateTypeDef,
    ListLineageGroupsRequestRequestTypeDef,
    ListModelBiasJobDefinitionsRequestListModelBiasJobDefinitionsPaginateTypeDef,
    ListModelBiasJobDefinitionsRequestRequestTypeDef,
    ListModelCardExportJobsRequestListModelCardExportJobsPaginateTypeDef,
    ListModelCardExportJobsRequestRequestTypeDef,
    ModelCardExportJobSummaryOutputTypeDef,
    ListModelCardVersionsRequestListModelCardVersionsPaginateTypeDef,
    ListModelCardVersionsRequestRequestTypeDef,
    ModelCardVersionSummaryOutputTypeDef,
    ListModelCardsRequestListModelCardsPaginateTypeDef,
    ListModelCardsRequestRequestTypeDef,
    ModelCardSummaryOutputTypeDef,
    ListModelExplainabilityJobDefinitionsRequestListModelExplainabilityJobDefinitionsPaginateTypeDef,
    ListModelExplainabilityJobDefinitionsRequestRequestTypeDef,
    ModelMetadataSummaryOutputTypeDef,
    ListModelPackageGroupsInputListModelPackageGroupsPaginateTypeDef,
    ListModelPackageGroupsInputRequestTypeDef,
    ModelPackageGroupSummaryOutputTypeDef,
    ListModelPackagesInputListModelPackagesPaginateTypeDef,
    ListModelPackagesInputRequestTypeDef,
    ModelPackageSummaryOutputTypeDef,
    ListModelQualityJobDefinitionsRequestListModelQualityJobDefinitionsPaginateTypeDef,
    ListModelQualityJobDefinitionsRequestRequestTypeDef,
    ListModelsInputListModelsPaginateTypeDef,
    ListModelsInputRequestTypeDef,
    ModelSummaryOutputTypeDef,
    ListMonitoringAlertHistoryRequestListMonitoringAlertHistoryPaginateTypeDef,
    ListMonitoringAlertHistoryRequestRequestTypeDef,
    MonitoringAlertHistorySummaryOutputTypeDef,
    ListMonitoringAlertsRequestListMonitoringAlertsPaginateTypeDef,
    ListMonitoringAlertsRequestRequestTypeDef,
    ListMonitoringExecutionsRequestListMonitoringExecutionsPaginateTypeDef,
    ListMonitoringExecutionsRequestRequestTypeDef,
    ListMonitoringSchedulesRequestListMonitoringSchedulesPaginateTypeDef,
    ListMonitoringSchedulesRequestRequestTypeDef,
    MonitoringScheduleSummaryOutputTypeDef,
    ListNotebookInstanceLifecycleConfigsInputListNotebookInstanceLifecycleConfigsPaginateTypeDef,
    ListNotebookInstanceLifecycleConfigsInputRequestTypeDef,
    NotebookInstanceLifecycleConfigSummaryOutputTypeDef,
    ListNotebookInstancesInputListNotebookInstancesPaginateTypeDef,
    ListNotebookInstancesInputRequestTypeDef,
    NotebookInstanceSummaryOutputTypeDef,
    ListPipelineExecutionStepsRequestListPipelineExecutionStepsPaginateTypeDef,
    ListPipelineExecutionStepsRequestRequestTypeDef,
    ListPipelineExecutionsRequestListPipelineExecutionsPaginateTypeDef,
    ListPipelineExecutionsRequestRequestTypeDef,
    PipelineExecutionSummaryOutputTypeDef,
    ListPipelineParametersForExecutionRequestListPipelineParametersForExecutionPaginateTypeDef,
    ListPipelineParametersForExecutionRequestRequestTypeDef,
    ParameterOutputTypeDef,
    ListPipelinesRequestListPipelinesPaginateTypeDef,
    ListPipelinesRequestRequestTypeDef,
    PipelineSummaryOutputTypeDef,
    ListProcessingJobsRequestListProcessingJobsPaginateTypeDef,
    ListProcessingJobsRequestRequestTypeDef,
    ProcessingJobSummaryOutputTypeDef,
    ListProjectsInputRequestTypeDef,
    ProjectSummaryOutputTypeDef,
    ListSpacesRequestListSpacesPaginateTypeDef,
    ListSpacesRequestRequestTypeDef,
    SpaceDetailsOutputTypeDef,
    ListStageDevicesRequestListStageDevicesPaginateTypeDef,
    ListStageDevicesRequestRequestTypeDef,
    ListStudioLifecycleConfigsRequestListStudioLifecycleConfigsPaginateTypeDef,
    ListStudioLifecycleConfigsRequestRequestTypeDef,
    StudioLifecycleConfigDetailsOutputTypeDef,
    ListSubscribedWorkteamsRequestListSubscribedWorkteamsPaginateTypeDef,
    ListSubscribedWorkteamsRequestRequestTypeDef,
    ListTagsInputListTagsPaginateTypeDef,
    ListTagsInputRequestTypeDef,
    ListTrainingJobsForHyperParameterTuningJobRequestListTrainingJobsForHyperParameterTuningJobPaginateTypeDef,
    ListTrainingJobsForHyperParameterTuningJobRequestRequestTypeDef,
    ListTrainingJobsRequestListTrainingJobsPaginateTypeDef,
    ListTrainingJobsRequestRequestTypeDef,
    ListTransformJobsRequestListTransformJobsPaginateTypeDef,
    ListTransformJobsRequestRequestTypeDef,
    TransformJobSummaryOutputTypeDef,
    ListTrialComponentsRequestListTrialComponentsPaginateTypeDef,
    ListTrialComponentsRequestRequestTypeDef,
    ListTrialsRequestListTrialsPaginateTypeDef,
    ListTrialsRequestRequestTypeDef,
    ListUserProfilesRequestListUserProfilesPaginateTypeDef,
    ListUserProfilesRequestRequestTypeDef,
    UserProfileDetailsOutputTypeDef,
    ListWorkforcesRequestListWorkforcesPaginateTypeDef,
    ListWorkforcesRequestRequestTypeDef,
    ListWorkteamsRequestListWorkteamsPaginateTypeDef,
    ListWorkteamsRequestRequestTypeDef,
    OidcMemberDefinitionOutputTypeDef,
    OidcMemberDefinitionTypeDef,
    MonitoringGroundTruthS3InputOutputTypeDef,
    MonitoringGroundTruthS3InputTypeDef,
    ModelDashboardEndpointOutputTypeDef,
    ModelDashboardIndicatorActionOutputTypeDef,
    S3ModelDataSourceOutputTypeDef,
    S3ModelDataSourceTypeDef,
    RealTimeInferenceConfigOutputTypeDef,
    RealTimeInferenceConfigTypeDef,
    ModelInputOutputTypeDef,
    ModelInputTypeDef,
    ModelLatencyThresholdOutputTypeDef,
    ModelLatencyThresholdTypeDef,
    ModelMetadataFilterTypeDef,
    ModelPackageStatusItemOutputTypeDef,
    ModelStepMetadataOutputTypeDef,
    MonitoringAppSpecificationOutputTypeDef,
    MonitoringAppSpecificationTypeDef,
    MonitoringClusterConfigOutputTypeDef,
    MonitoringClusterConfigTypeDef,
    MonitoringCsvDatasetFormatOutputTypeDef,
    MonitoringCsvDatasetFormatTypeDef,
    MonitoringJsonDatasetFormatOutputTypeDef,
    MonitoringJsonDatasetFormatTypeDef,
    MonitoringS3OutputOutputTypeDef,
    MonitoringS3OutputTypeDef,
    ScheduleConfigOutputTypeDef,
    ScheduleConfigTypeDef,
    NotificationConfigurationOutputTypeDef,
    S3StorageConfigOutputTypeDef,
    S3StorageConfigTypeDef,
    OidcConfigForResponseOutputTypeDef,
    OnlineStoreSecurityConfigOutputTypeDef,
    TtlDurationOutputTypeDef,
    OnlineStoreSecurityConfigTypeDef,
    TtlDurationTypeDef,
    TargetPlatformOutputTypeDef,
    TargetPlatformTypeDef,
    OutputParameterTypeDef,
    PaginatorConfigTypeDef,
    ParameterTypeDef,
    ParentOutputTypeDef,
    ProductionVariantStatusOutputTypeDef,
    PhaseOutputTypeDef,
    PhaseTypeDef,
    ProcessingJobStepMetadataOutputTypeDef,
    QualityCheckStepMetadataOutputTypeDef,
    RegisterModelStepMetadataOutputTypeDef,
    TrainingJobStepMetadataOutputTypeDef,
    TransformJobStepMetadataOutputTypeDef,
    TuningJobStepMetaDataOutputTypeDef,
    SelectiveExecutionResultOutputTypeDef,
    ProcessingClusterConfigOutputTypeDef,
    ProcessingClusterConfigTypeDef,
    ProcessingFeatureStoreOutputOutputTypeDef,
    ProcessingFeatureStoreOutputTypeDef,
    ProcessingS3InputOutputTypeDef,
    ProcessingS3InputTypeDef,
    ProcessingS3OutputOutputTypeDef,
    ProcessingS3OutputTypeDef,
    ProductionVariantCoreDumpConfigOutputTypeDef,
    ProductionVariantCoreDumpConfigTypeDef,
    ProfilerConfigForUpdateTypeDef,
    PropertyNameQueryTypeDef,
    ProvisioningParameterOutputTypeDef,
    ProvisioningParameterTypeDef,
    USDOutputTypeDef,
    USDTypeDef,
    PutModelPackageGroupPolicyInputRequestTypeDef,
    PutModelPackageGroupPolicyOutputOutputTypeDef,
    QueryFiltersTypeDef,
    VertexOutputTypeDef,
    RStudioServerProAppSettingsOutputTypeDef,
    RStudioServerProAppSettingsTypeDef,
    RecommendationJobCompiledOutputConfigTypeDef,
    RecommendationJobPayloadConfigOutputTypeDef,
    RecommendationJobPayloadConfigTypeDef,
    RecommendationJobResourceLimitOutputTypeDef,
    RecommendationJobVpcConfigOutputTypeDef,
    RecommendationJobResourceLimitTypeDef,
    RecommendationJobVpcConfigTypeDef,
    RenderableTaskTypeDef,
    RenderingErrorOutputTypeDef,
    ResourceConfigForUpdateTypeDef,
    ResponseMetadataTypeDef,
    RetryPipelineExecutionResponseOutputTypeDef,
    SearchRequestRequestTypeDef,
    SearchRequestSearchPaginateTypeDef,
    SelectedStepOutputTypeDef,
    SelectedStepTypeDef,
    SendPipelineExecutionStepFailureRequestRequestTypeDef,
    SendPipelineExecutionStepFailureResponseOutputTypeDef,
    SendPipelineExecutionStepSuccessResponseOutputTypeDef,
    ShadowModelVariantConfigOutputTypeDef,
    ShadowModelVariantConfigTypeDef,
    SharingSettingsOutputTypeDef,
    SharingSettingsTypeDef,
    SourceAlgorithmOutputTypeDef,
    SourceAlgorithmTypeDef,
    SourceIpConfigOutputTypeDef,
    StartEdgeDeploymentStageRequestRequestTypeDef,
    StartInferenceExperimentRequestRequestTypeDef,
    StartInferenceExperimentResponseOutputTypeDef,
    StartMonitoringScheduleRequestRequestTypeDef,
    StartNotebookInstanceInputRequestTypeDef,
    StartPipelineExecutionResponseOutputTypeDef,
    StopAutoMLJobRequestRequestTypeDef,
    StopCompilationJobRequestRequestTypeDef,
    StopEdgeDeploymentStageRequestRequestTypeDef,
    StopEdgePackagingJobRequestRequestTypeDef,
    StopHyperParameterTuningJobRequestRequestTypeDef,
    StopInferenceExperimentResponseOutputTypeDef,
    StopInferenceRecommendationsJobRequestRequestTypeDef,
    StopLabelingJobRequestRequestTypeDef,
    StopMonitoringScheduleRequestRequestTypeDef,
    StopNotebookInstanceInputRequestTypeDef,
    StopPipelineExecutionRequestRequestTypeDef,
    StopPipelineExecutionResponseOutputTypeDef,
    StopProcessingJobRequestRequestTypeDef,
    StopTrainingJobRequestRequestTypeDef,
    StopTransformJobRequestRequestTypeDef,
    TimeSeriesConfigOutputTypeDef,
    TimeSeriesConfigTypeDef,
    TimeSeriesTransformationsOutputTypeDef,
    TimeSeriesTransformationsTypeDef,
    TrainingRepositoryAuthConfigOutputTypeDef,
    TrainingRepositoryAuthConfigTypeDef,
    TransformS3DataSourceOutputTypeDef,
    TransformS3DataSourceTypeDef,
    UpdateActionRequestRequestTypeDef,
    UpdateActionResponseOutputTypeDef,
    UpdateAppImageConfigResponseOutputTypeDef,
    UpdateArtifactRequestRequestTypeDef,
    UpdateArtifactResponseOutputTypeDef,
    UpdateCodeRepositoryOutputOutputTypeDef,
    UpdateContextRequestRequestTypeDef,
    UpdateContextResponseOutputTypeDef,
    UpdateDomainResponseOutputTypeDef,
    VariantPropertyTypeDef,
    UpdateEndpointOutputOutputTypeDef,
    UpdateEndpointWeightsAndCapacitiesOutputOutputTypeDef,
    UpdateExperimentRequestRequestTypeDef,
    UpdateExperimentResponseOutputTypeDef,
    UpdateFeatureGroupResponseOutputTypeDef,
    UpdateHubRequestRequestTypeDef,
    UpdateHubResponseOutputTypeDef,
    UpdateImageRequestRequestTypeDef,
    UpdateImageResponseOutputTypeDef,
    UpdateImageVersionRequestRequestTypeDef,
    UpdateImageVersionResponseOutputTypeDef,
    UpdateInferenceExperimentResponseOutputTypeDef,
    UpdateModelCardRequestRequestTypeDef,
    UpdateModelCardResponseOutputTypeDef,
    UpdateModelPackageOutputOutputTypeDef,
    UpdateMonitoringAlertRequestRequestTypeDef,
    UpdateMonitoringAlertResponseOutputTypeDef,
    UpdateMonitoringScheduleResponseOutputTypeDef,
    UpdatePipelineExecutionResponseOutputTypeDef,
    UpdatePipelineResponseOutputTypeDef,
    UpdateProjectOutputOutputTypeDef,
    UpdateSpaceResponseOutputTypeDef,
    UpdateTrainingJobResponseOutputTypeDef,
    UpdateTrialComponentResponseOutputTypeDef,
    UpdateTrialRequestRequestTypeDef,
    UpdateTrialResponseOutputTypeDef,
    UpdateUserProfileResponseOutputTypeDef,
    WorkforceVpcConfigResponseOutputTypeDef,
    ActionSummaryOutputTypeDef,
    AddTagsInputRequestTypeDef,
    CreateExperimentRequestRequestTypeDef,
    CreateImageRequestRequestTypeDef,
    CreateModelPackageGroupInputRequestTypeDef,
    CreateStudioLifecycleConfigRequestRequestTypeDef,
    ImportHubContentRequestRequestTypeDef,
    AddTagsOutputOutputTypeDef,
    ListTagsOutputOutputTypeDef,
    AutoRollbackConfigOutputTypeDef,
    AutoRollbackConfigTypeDef,
    HyperParameterAlgorithmSpecificationOutputTypeDef,
    HyperParameterAlgorithmSpecificationTypeDef,
    AlgorithmStatusDetailsOutputTypeDef,
    ListAlgorithmsOutputOutputTypeDef,
    ListAppsResponseOutputTypeDef,
    ArtifactSourceOutputTypeDef,
    ArtifactSourceTypeDef,
    AsyncInferenceOutputConfigOutputTypeDef,
    AsyncInferenceOutputConfigTypeDef,
    AutoMLCandidateGenerationConfigOutputTypeDef,
    CandidateGenerationConfigOutputTypeDef,
    AutoMLCandidateGenerationConfigTypeDef,
    CandidateGenerationConfigTypeDef,
    AutoMLDataSourceOutputTypeDef,
    AutoMLDataSourceTypeDef,
    ImageClassificationJobConfigOutputTypeDef,
    TextClassificationJobConfigOutputTypeDef,
    ImageClassificationJobConfigTypeDef,
    TextClassificationJobConfigTypeDef,
    ResolvedAttributesOutputTypeDef,
    AutoMLJobSummaryOutputTypeDef,
    AutoMLProblemTypeResolvedAttributesOutputTypeDef,
    AutoMLSecurityConfigOutputTypeDef,
    LabelingJobResourceConfigOutputTypeDef,
    MonitoringNetworkConfigOutputTypeDef,
    NetworkConfigOutputTypeDef,
    AutoMLSecurityConfigTypeDef,
    LabelingJobResourceConfigTypeDef,
    MonitoringNetworkConfigTypeDef,
    NetworkConfigTypeDef,
    BiasOutputTypeDef,
    DriftCheckModelDataQualityOutputTypeDef,
    DriftCheckModelQualityOutputTypeDef,
    ExplainabilityOutputTypeDef,
    ModelDataQualityOutputTypeDef,
    ModelQualityOutputTypeDef,
    BiasTypeDef,
    DriftCheckModelDataQualityTypeDef,
    DriftCheckModelQualityTypeDef,
    ExplainabilityTypeDef,
    ModelDataQualityTypeDef,
    ModelQualityTypeDef,
    CallbackStepMetadataOutputTypeDef,
    LambdaStepMetadataOutputTypeDef,
    CandidatePropertiesOutputTypeDef,
    CanvasAppSettingsOutputTypeDef,
    CanvasAppSettingsTypeDef,
    RollingUpdatePolicyOutputTypeDef,
    TrafficRoutingConfigOutputTypeDef,
    RollingUpdatePolicyTypeDef,
    TrafficRoutingConfigTypeDef,
    InferenceExperimentDataStorageConfigOutputTypeDef,
    InferenceExperimentDataStorageConfigTypeDef,
    DataCaptureConfigOutputTypeDef,
    DataCaptureConfigTypeDef,
    EnvironmentParameterRangesOutputTypeDef,
    EnvironmentParameterRangesTypeDef,
    ClarifyShapConfigOutputTypeDef,
    ClarifyShapConfigTypeDef,
    CodeRepositorySummaryOutputTypeDef,
    DescribeCodeRepositoryOutputOutputTypeDef,
    DebugHookConfigOutputTypeDef,
    DebugHookConfigTypeDef,
    ListCompilationJobsResponseOutputTypeDef,
    ContextSummaryOutputTypeDef,
    CreateContextRequestRequestTypeDef,
    TuningJobCompletionCriteriaOutputTypeDef,
    TuningJobCompletionCriteriaTypeDef,
    CreateActionRequestRequestTypeDef,
    CreateTrialRequestRequestTypeDef,
    CreateAppRequestRequestTypeDef,
    JupyterServerAppSettingsTypeDef,
    RStudioServerProDomainSettingsForUpdateTypeDef,
    RStudioServerProDomainSettingsTypeDef,
    TensorBoardAppSettingsTypeDef,
    CreateCodeRepositoryInputRequestTypeDef,
    CreateDeviceFleetRequestRequestTypeDef,
    CreateEdgePackagingJobRequestRequestTypeDef,
    UpdateDeviceFleetRequestRequestTypeDef,
    CreateHubRequestRequestTypeDef,
    CreateHumanTaskUiRequestRequestTypeDef,
    CreateModelCardExportJobRequestRequestTypeDef,
    CreateModelCardRequestRequestTypeDef,
    CreateNotebookInstanceInputRequestTypeDef,
    UpdateNotebookInstanceInputRequestTypeDef,
    CreateNotebookInstanceLifecycleConfigInputRequestTypeDef,
    UpdateNotebookInstanceLifecycleConfigInputRequestTypeDef,
    RetryPipelineExecutionRequestRequestTypeDef,
    UpdatePipelineExecutionRequestRequestTypeDef,
    CreatePipelineRequestRequestTypeDef,
    UpdatePipelineRequestRequestTypeDef,
    CreateTrialComponentRequestRequestTypeDef,
    UpdateTrialComponentRequestRequestTypeDef,
    CreateWorkforceRequestRequestTypeDef,
    UpdateWorkforceRequestRequestTypeDef,
    KernelGatewayAppSettingsTypeDef,
    RSessionAppSettingsTypeDef,
    ModelBiasBaselineConfigOutputTypeDef,
    ModelExplainabilityBaselineConfigOutputTypeDef,
    ModelQualityBaselineConfigOutputTypeDef,
    DataQualityBaselineConfigOutputTypeDef,
    MonitoringBaselineConfigOutputTypeDef,
    ModelBiasBaselineConfigTypeDef,
    ModelExplainabilityBaselineConfigTypeDef,
    ModelQualityBaselineConfigTypeDef,
    DataQualityBaselineConfigTypeDef,
    MonitoringBaselineConfigTypeDef,
    DataSourceOutputTypeDef,
    DataSourceTypeDef,
    DatasetDefinitionOutputTypeDef,
    DatasetDefinitionTypeDef,
    DeleteDomainRequestRequestTypeDef,
    DeploymentRecommendationOutputTypeDef,
    DeploymentStageStatusSummaryOutputTypeDef,
    DeploymentStageTypeDef,
    DescribeAppResponseOutputTypeDef,
    JupyterServerAppSettingsOutputTypeDef,
    KernelGatewayAppSettingsOutputTypeDef,
    RSessionAppSettingsOutputTypeDef,
    RStudioServerProDomainSettingsOutputTypeDef,
    TensorBoardAppSettingsOutputTypeDef,
    DescribeDeviceFleetResponseOutputTypeDef,
    DescribeDeviceResponseOutputTypeDef,
    DescribeEdgePackagingJobResponseOutputTypeDef,
    DescribeEndpointInputEndpointDeletedWaitTypeDef,
    DescribeEndpointInputEndpointInServiceWaitTypeDef,
    DescribeImageRequestImageCreatedWaitTypeDef,
    DescribeImageRequestImageDeletedWaitTypeDef,
    DescribeImageRequestImageUpdatedWaitTypeDef,
    DescribeImageVersionRequestImageVersionCreatedWaitTypeDef,
    DescribeImageVersionRequestImageVersionDeletedWaitTypeDef,
    DescribeNotebookInstanceInputNotebookInstanceDeletedWaitTypeDef,
    DescribeNotebookInstanceInputNotebookInstanceInServiceWaitTypeDef,
    DescribeNotebookInstanceInputNotebookInstanceStoppedWaitTypeDef,
    DescribeProcessingJobRequestProcessingJobCompletedOrStoppedWaitTypeDef,
    DescribeTrainingJobRequestTrainingJobCompletedOrStoppedWaitTypeDef,
    DescribeTransformJobRequestTransformJobCompletedOrStoppedWaitTypeDef,
    ExperimentSummaryOutputTypeDef,
    FeatureGroupSummaryOutputTypeDef,
    DescribeFeatureMetadataResponseOutputTypeDef,
    FeatureMetadataOutputTypeDef,
    DescribeHubContentResponseOutputTypeDef,
    DescribeHubResponseOutputTypeDef,
    DescribeHumanTaskUiResponseOutputTypeDef,
    InferenceExperimentSummaryOutputTypeDef,
    DescribeModelCardExportJobResponseOutputTypeDef,
    ListMonitoringExecutionsResponseOutputTypeDef,
    DescribeNotebookInstanceLifecycleConfigOutputOutputTypeDef,
    DescribeNotebookInstanceOutputOutputTypeDef,
    DescribeSubscribedWorkteamResponseOutputTypeDef,
    ListSubscribedWorkteamsResponseOutputTypeDef,
    TrainingJobSummaryOutputTypeDef,
    TrialSummaryOutputTypeDef,
    DesiredWeightAndCapacityTypeDef,
    ListStageDevicesResponseOutputTypeDef,
    ListDeviceFleetsResponseOutputTypeDef,
    DeviceSummaryOutputTypeDef,
    RegisterDevicesRequestRequestTypeDef,
    UpdateDevicesRequestRequestTypeDef,
    ListDomainsResponseOutputTypeDef,
    DriftCheckBiasOutputTypeDef,
    DriftCheckExplainabilityOutputTypeDef,
    DriftCheckBiasTypeDef,
    DriftCheckExplainabilityTypeDef,
    ListEdgeDeploymentPlansResponseOutputTypeDef,
    GetDeviceFleetReportResponseOutputTypeDef,
    ListEdgePackagingJobsResponseOutputTypeDef,
    ListEndpointConfigsOutputOutputTypeDef,
    EndpointOutputConfigurationOutputTypeDef,
    EndpointPerformanceOutputTypeDef,
    ListEndpointsOutputOutputTypeDef,
    ModelConfigurationOutputTypeDef,
    UpdateFeatureMetadataRequestRequestTypeDef,
    NestedFiltersTypeDef,
    HyperParameterTrainingJobSummaryOutputTypeDef,
    ListFlowDefinitionsResponseOutputTypeDef,
    GetSearchSuggestionsResponseOutputTypeDef,
    UpdateCodeRepositoryInputRequestTypeDef,
    ListHubContentVersionsResponseOutputTypeDef,
    ListHubContentsResponseOutputTypeDef,
    ListHubsResponseOutputTypeDef,
    HumanLoopActivationConfigOutputTypeDef,
    HumanLoopActivationConfigTypeDef,
    ListHumanTaskUisResponseOutputTypeDef,
    HyperParameterTuningResourceConfigOutputTypeDef,
    HyperParameterTuningResourceConfigTypeDef,
    HyperParameterTuningJobSummaryOutputTypeDef,
    HyperParameterTuningJobStrategyConfigOutputTypeDef,
    HyperParameterTuningJobStrategyConfigTypeDef,
    HyperParameterTuningJobWarmStartConfigOutputTypeDef,
    HyperParameterTuningJobWarmStartConfigTypeDef,
    UserContextOutputTypeDef,
    ImageConfigOutputTypeDef,
    ImageConfigTypeDef,
    ListImagesResponseOutputTypeDef,
    ListImageVersionsResponseOutputTypeDef,
    ListInferenceRecommendationsJobsResponseOutputTypeDef,
    ResourceConfigOutputTypeDef,
    ResourceConfigTypeDef,
    ParameterRangesOutputTypeDef,
    ParameterRangeOutputTypeDef,
    ParameterRangeTypeDef,
    ParameterRangesTypeDef,
    KernelGatewayImageConfigOutputTypeDef,
    KernelGatewayImageConfigTypeDef,
    LabelingJobForWorkteamSummaryOutputTypeDef,
    LabelingJobDataSourceOutputTypeDef,
    LabelingJobDataSourceTypeDef,
    ListLineageGroupsResponseOutputTypeDef,
    ListDataQualityJobDefinitionsResponseOutputTypeDef,
    ListModelBiasJobDefinitionsResponseOutputTypeDef,
    ListModelExplainabilityJobDefinitionsResponseOutputTypeDef,
    ListModelQualityJobDefinitionsResponseOutputTypeDef,
    ListModelCardExportJobsResponseOutputTypeDef,
    ListModelCardVersionsResponseOutputTypeDef,
    ListModelCardsResponseOutputTypeDef,
    ListModelMetadataResponseOutputTypeDef,
    ListModelPackageGroupsOutputOutputTypeDef,
    ListModelPackagesOutputOutputTypeDef,
    ListModelsOutputOutputTypeDef,
    ListMonitoringAlertHistoryResponseOutputTypeDef,
    ListMonitoringSchedulesResponseOutputTypeDef,
    ListNotebookInstanceLifecycleConfigsOutputOutputTypeDef,
    ListNotebookInstancesOutputOutputTypeDef,
    ListPipelineExecutionsResponseOutputTypeDef,
    ListPipelineParametersForExecutionResponseOutputTypeDef,
    ListPipelinesResponseOutputTypeDef,
    ListProcessingJobsResponseOutputTypeDef,
    ListProjectsOutputOutputTypeDef,
    ListSpacesResponseOutputTypeDef,
    ListStudioLifecycleConfigsResponseOutputTypeDef,
    ListTransformJobsResponseOutputTypeDef,
    ListUserProfilesResponseOutputTypeDef,
    MemberDefinitionOutputTypeDef,
    MemberDefinitionTypeDef,
    MonitoringAlertActionsOutputTypeDef,
    ModelDataSourceOutputTypeDef,
    ModelDataSourceTypeDef,
    ModelInfrastructureConfigOutputTypeDef,
    ModelInfrastructureConfigTypeDef,
    ModelPackageContainerDefinitionOutputTypeDef,
    ModelPackageContainerDefinitionTypeDef,
    RecommendationJobStoppingConditionsOutputTypeDef,
    RecommendationJobStoppingConditionsTypeDef,
    ModelMetadataSearchExpressionTypeDef,
    ModelPackageStatusDetailsOutputTypeDef,
    MonitoringResourcesOutputTypeDef,
    MonitoringResourcesTypeDef,
    MonitoringDatasetFormatOutputTypeDef,
    MonitoringDatasetFormatTypeDef,
    MonitoringOutputOutputTypeDef,
    MonitoringOutputTypeDef,
    OfflineStoreConfigOutputTypeDef,
    OfflineStoreConfigTypeDef,
    OnlineStoreConfigOutputTypeDef,
    OnlineStoreConfigTypeDef,
    OnlineStoreConfigUpdateTypeDef,
    OutputConfigOutputTypeDef,
    OutputConfigTypeDef,
    SendPipelineExecutionStepSuccessRequestRequestTypeDef,
    PendingProductionVariantSummaryOutputTypeDef,
    ProductionVariantSummaryOutputTypeDef,
    TrafficPatternOutputTypeDef,
    TrafficPatternTypeDef,
    ProcessingResourcesOutputTypeDef,
    ProcessingResourcesTypeDef,
    ProcessingOutputOutputTypeDef,
    ProcessingOutputTypeDef,
    ProductionVariantOutputTypeDef,
    ProductionVariantTypeDef,
    SuggestionQueryTypeDef,
    ServiceCatalogProvisioningDetailsOutputTypeDef,
    ServiceCatalogProvisioningDetailsTypeDef,
    ServiceCatalogProvisioningUpdateDetailsTypeDef,
    PublicWorkforceTaskPriceOutputTypeDef,
    PublicWorkforceTaskPriceTypeDef,
    QueryLineageRequestRequestTypeDef,
    QueryLineageResponseOutputTypeDef,
    RecommendationJobOutputConfigTypeDef,
    RecommendationJobContainerConfigOutputTypeDef,
    RecommendationJobContainerConfigTypeDef,
    RenderUiTemplateRequestRequestTypeDef,
    RenderUiTemplateResponseOutputTypeDef,
    UpdateTrainingJobRequestRequestTypeDef,
    SelectiveExecutionConfigOutputTypeDef,
    SelectiveExecutionConfigTypeDef,
    ShadowModeConfigOutputTypeDef,
    ShadowModeConfigTypeDef,
    SourceAlgorithmSpecificationOutputTypeDef,
    SourceAlgorithmSpecificationTypeDef,
    TimeSeriesForecastingJobConfigOutputTypeDef,
    TimeSeriesForecastingJobConfigTypeDef,
    TrainingImageConfigOutputTypeDef,
    TrainingImageConfigTypeDef,
    TransformDataSourceOutputTypeDef,
    TransformDataSourceTypeDef,
    WorkforceOutputTypeDef,
    ListActionsResponseOutputTypeDef,
    ArtifactSummaryOutputTypeDef,
    CreateArtifactRequestRequestTypeDef,
    DeleteArtifactRequestRequestTypeDef,
    AsyncInferenceConfigOutputTypeDef,
    AsyncInferenceConfigTypeDef,
    TabularJobConfigOutputTypeDef,
    TabularJobConfigTypeDef,
    AutoMLChannelOutputTypeDef,
    AutoMLJobChannelOutputTypeDef,
    AutoMLChannelTypeDef,
    AutoMLJobChannelTypeDef,
    ListAutoMLJobsResponseOutputTypeDef,
    AutoMLResolvedAttributesOutputTypeDef,
    AutoMLJobConfigOutputTypeDef,
    LabelingJobAlgorithmsConfigOutputTypeDef,
    AutoMLJobConfigTypeDef,
    LabelingJobAlgorithmsConfigTypeDef,
    ModelMetricsOutputTypeDef,
    ModelMetricsTypeDef,
    PipelineExecutionStepMetadataOutputTypeDef,
    AutoMLCandidateOutputTypeDef,
    BlueGreenUpdatePolicyOutputTypeDef,
    BlueGreenUpdatePolicyTypeDef,
    EndpointInputConfigurationOutputTypeDef,
    EndpointInputConfigurationTypeDef,
    ClarifyExplainerConfigOutputTypeDef,
    ClarifyExplainerConfigTypeDef,
    ListCodeRepositoriesOutputOutputTypeDef,
    ListContextsResponseOutputTypeDef,
    DomainSettingsForUpdateTypeDef,
    DomainSettingsTypeDef,
    DefaultSpaceSettingsTypeDef,
    SpaceSettingsTypeDef,
    UserSettingsTypeDef,
    ChannelOutputTypeDef,
    ChannelTypeDef,
    ProcessingInputOutputTypeDef,
    ProcessingInputTypeDef,
    DescribeEdgeDeploymentPlanResponseOutputTypeDef,
    CreateEdgeDeploymentPlanRequestRequestTypeDef,
    CreateEdgeDeploymentStageRequestRequestTypeDef,
    DefaultSpaceSettingsOutputTypeDef,
    SpaceSettingsOutputTypeDef,
    DomainSettingsOutputTypeDef,
    UserSettingsOutputTypeDef,
    ListExperimentsResponseOutputTypeDef,
    ListFeatureGroupsResponseOutputTypeDef,
    ListInferenceExperimentsResponseOutputTypeDef,
    ListTrainingJobsResponseOutputTypeDef,
    ListTrialsResponseOutputTypeDef,
    UpdateEndpointWeightsAndCapacitiesInputRequestTypeDef,
    ListDevicesResponseOutputTypeDef,
    DriftCheckBaselinesOutputTypeDef,
    DriftCheckBaselinesTypeDef,
    InferenceRecommendationOutputTypeDef,
    RecommendationJobInferenceBenchmarkOutputTypeDef,
    SearchExpressionTypeDef,
    ListTrainingJobsForHyperParameterTuningJobResponseOutputTypeDef,
    ListHyperParameterTuningJobsResponseOutputTypeDef,
    AssociationSummaryOutputTypeDef,
    DescribeActionResponseOutputTypeDef,
    DescribeArtifactResponseOutputTypeDef,
    DescribeContextResponseOutputTypeDef,
    DescribeExperimentResponseOutputTypeDef,
    DescribeLineageGroupResponseOutputTypeDef,
    DescribeModelCardResponseOutputTypeDef,
    DescribeModelPackageGroupOutputOutputTypeDef,
    DescribePipelineResponseOutputTypeDef,
    DescribeTrialComponentResponseOutputTypeDef,
    DescribeTrialResponseOutputTypeDef,
    ExperimentOutputTypeDef,
    ModelCardOutputTypeDef,
    ModelDashboardModelCardOutputTypeDef,
    ModelPackageGroupOutputTypeDef,
    PipelineOutputTypeDef,
    TrialComponentSimpleSummaryOutputTypeDef,
    TrialComponentSummaryOutputTypeDef,
    HyperParameterTuningJobConfigOutputTypeDef,
    HyperParameterSpecificationOutputTypeDef,
    HyperParameterSpecificationTypeDef,
    HyperParameterTuningJobConfigTypeDef,
    AppImageConfigDetailsOutputTypeDef,
    DescribeAppImageConfigResponseOutputTypeDef,
    CreateAppImageConfigRequestRequestTypeDef,
    UpdateAppImageConfigRequestRequestTypeDef,
    ListLabelingJobsForWorkteamResponseOutputTypeDef,
    LabelingJobInputConfigOutputTypeDef,
    LabelingJobInputConfigTypeDef,
    WorkteamOutputTypeDef,
    CreateWorkteamRequestRequestTypeDef,
    UpdateWorkteamRequestRequestTypeDef,
    MonitoringAlertSummaryOutputTypeDef,
    ContainerDefinitionOutputTypeDef,
    ContainerDefinitionTypeDef,
    ModelVariantConfigSummaryOutputTypeDef,
    ModelVariantConfigTypeDef,
    AdditionalInferenceSpecificationDefinitionOutputTypeDef,
    InferenceSpecificationOutputTypeDef,
    AdditionalInferenceSpecificationDefinitionTypeDef,
    InferenceSpecificationTypeDef,
    ListModelMetadataRequestListModelMetadataPaginateTypeDef,
    ListModelMetadataRequestRequestTypeDef,
    BatchTransformInputOutputTypeDef,
    BatchTransformInputTypeDef,
    MonitoringOutputConfigOutputTypeDef,
    MonitoringOutputConfigTypeDef,
    DescribeFeatureGroupResponseOutputTypeDef,
    FeatureGroupOutputTypeDef,
    CreateFeatureGroupRequestRequestTypeDef,
    UpdateFeatureGroupRequestRequestTypeDef,
    DescribeCompilationJobResponseOutputTypeDef,
    CreateCompilationJobRequestRequestTypeDef,
    PendingDeploymentSummaryOutputTypeDef,
    ProcessingOutputConfigOutputTypeDef,
    ProcessingOutputConfigTypeDef,
    GetSearchSuggestionsRequestRequestTypeDef,
    DescribeProjectOutputOutputTypeDef,
    ProjectOutputTypeDef,
    CreateProjectInputRequestTypeDef,
    UpdateProjectInputRequestTypeDef,
    HumanLoopConfigOutputTypeDef,
    HumanTaskConfigOutputTypeDef,
    HumanLoopConfigTypeDef,
    HumanTaskConfigTypeDef,
    DescribePipelineExecutionResponseOutputTypeDef,
    PipelineExecutionOutputTypeDef,
    StartPipelineExecutionRequestRequestTypeDef,
    AlgorithmSpecificationOutputTypeDef,
    AlgorithmSpecificationTypeDef,
    TransformInputOutputTypeDef,
    TransformInputTypeDef,
    DescribeWorkforceResponseOutputTypeDef,
    ListWorkforcesResponseOutputTypeDef,
    UpdateWorkforceResponseOutputTypeDef,
    ListArtifactsResponseOutputTypeDef,
    AutoMLProblemTypeConfigOutputTypeDef,
    AutoMLProblemTypeConfigTypeDef,
    CreateAutoMLJobRequestRequestTypeDef,
    PipelineExecutionStepOutputTypeDef,
    DescribeAutoMLJobResponseOutputTypeDef,
    ListCandidatesForAutoMLJobResponseOutputTypeDef,
    DeploymentConfigOutputTypeDef,
    DeploymentConfigTypeDef,
    RecommendationJobInputConfigOutputTypeDef,
    RecommendationJobInputConfigTypeDef,
    ExplainerConfigOutputTypeDef,
    ExplainerConfigTypeDef,
    CreateSpaceRequestRequestTypeDef,
    UpdateSpaceRequestRequestTypeDef,
    CreateDomainRequestRequestTypeDef,
    CreateUserProfileRequestRequestTypeDef,
    UpdateDomainRequestRequestTypeDef,
    UpdateUserProfileRequestRequestTypeDef,
    HyperParameterTrainingJobDefinitionOutputTypeDef,
    TrainingJobDefinitionOutputTypeDef,
    HyperParameterTrainingJobDefinitionTypeDef,
    TrainingJobDefinitionTypeDef,
    DescribeSpaceResponseOutputTypeDef,
    DescribeDomainResponseOutputTypeDef,
    DescribeUserProfileResponseOutputTypeDef,
    InferenceRecommendationsJobStepOutputTypeDef,
    ListAssociationsResponseOutputTypeDef,
    TrialOutputTypeDef,
    ListTrialComponentsResponseOutputTypeDef,
    TrainingSpecificationOutputTypeDef,
    TrainingSpecificationTypeDef,
    ListAppImageConfigsResponseOutputTypeDef,
    LabelingJobSummaryOutputTypeDef,
    DescribeWorkteamResponseOutputTypeDef,
    ListWorkteamsResponseOutputTypeDef,
    UpdateWorkteamResponseOutputTypeDef,
    ListMonitoringAlertsResponseOutputTypeDef,
    DescribeModelOutputOutputTypeDef,
    ModelOutputTypeDef,
    CreateModelInputRequestTypeDef,
    DescribeInferenceExperimentResponseOutputTypeDef,
    CreateInferenceExperimentRequestRequestTypeDef,
    StopInferenceExperimentRequestRequestTypeDef,
    UpdateInferenceExperimentRequestRequestTypeDef,
    BatchDescribeModelPackageSummaryOutputTypeDef,
    UpdateModelPackageInputRequestTypeDef,
    DataQualityJobInputOutputTypeDef,
    ModelBiasJobInputOutputTypeDef,
    ModelExplainabilityJobInputOutputTypeDef,
    ModelQualityJobInputOutputTypeDef,
    MonitoringInputOutputTypeDef,
    DataQualityJobInputTypeDef,
    ModelBiasJobInputTypeDef,
    ModelExplainabilityJobInputTypeDef,
    ModelQualityJobInputTypeDef,
    MonitoringInputTypeDef,
    DescribeProcessingJobResponseOutputTypeDef,
    ProcessingJobOutputTypeDef,
    CreateProcessingJobRequestRequestTypeDef,
    DescribeFlowDefinitionResponseOutputTypeDef,
    DescribeLabelingJobResponseOutputTypeDef,
    CreateFlowDefinitionRequestRequestTypeDef,
    CreateLabelingJobRequestRequestTypeDef,
    DescribeTrainingJobResponseOutputTypeDef,
    TrainingJobOutputTypeDef,
    CreateTrainingJobRequestRequestTypeDef,
    DescribeTransformJobResponseOutputTypeDef,
    TransformJobDefinitionOutputTypeDef,
    TransformJobOutputTypeDef,
    CreateTransformJobRequestRequestTypeDef,
    TransformJobDefinitionTypeDef,
    DescribeAutoMLJobV2ResponseOutputTypeDef,
    CreateAutoMLJobV2RequestRequestTypeDef,
    ListPipelineExecutionStepsResponseOutputTypeDef,
    CreateEndpointInputRequestTypeDef,
    UpdateEndpointInputRequestTypeDef,
    DescribeInferenceRecommendationsJobResponseOutputTypeDef,
    CreateInferenceRecommendationsJobRequestRequestTypeDef,
    DescribeEndpointConfigOutputOutputTypeDef,
    DescribeEndpointOutputOutputTypeDef,
    CreateEndpointConfigInputRequestTypeDef,
    DescribeHyperParameterTuningJobResponseOutputTypeDef,
    HyperParameterTuningJobSearchEntityOutputTypeDef,
    CreateHyperParameterTuningJobRequestRequestTypeDef,
    ListInferenceRecommendationsJobStepsResponseOutputTypeDef,
    ListLabelingJobsResponseOutputTypeDef,
    BatchDescribeModelPackageOutputOutputTypeDef,
    DescribeDataQualityJobDefinitionResponseOutputTypeDef,
    DescribeModelBiasJobDefinitionResponseOutputTypeDef,
    DescribeModelExplainabilityJobDefinitionResponseOutputTypeDef,
    DescribeModelQualityJobDefinitionResponseOutputTypeDef,
    MonitoringJobDefinitionOutputTypeDef,
    CreateDataQualityJobDefinitionRequestRequestTypeDef,
    CreateModelBiasJobDefinitionRequestRequestTypeDef,
    CreateModelExplainabilityJobDefinitionRequestRequestTypeDef,
    CreateModelQualityJobDefinitionRequestRequestTypeDef,
    MonitoringJobDefinitionTypeDef,
    AlgorithmValidationProfileOutputTypeDef,
    ModelPackageValidationProfileOutputTypeDef,
    TrialComponentSourceDetailOutputTypeDef,
    AlgorithmValidationProfileTypeDef,
    ModelPackageValidationProfileTypeDef,
    MonitoringScheduleConfigOutputTypeDef,
    MonitoringScheduleConfigTypeDef,
    AlgorithmValidationSpecificationOutputTypeDef,
    ModelPackageValidationSpecificationOutputTypeDef,
    TrialComponentOutputTypeDef,
    AlgorithmValidationSpecificationTypeDef,
    ModelPackageValidationSpecificationTypeDef,
    DescribeMonitoringScheduleResponseOutputTypeDef,
    ModelDashboardMonitoringScheduleOutputTypeDef,
    MonitoringScheduleOutputTypeDef,
    CreateMonitoringScheduleRequestRequestTypeDef,
    UpdateMonitoringScheduleRequestRequestTypeDef,
    DescribeAlgorithmOutputOutputTypeDef,
    DescribeModelPackageOutputOutputTypeDef,
    ModelPackageOutputTypeDef,
    CreateAlgorithmInputRequestTypeDef,
    CreateModelPackageInputRequestTypeDef,
    ModelDashboardModelOutputTypeDef,
    EndpointOutputTypeDef,
    SearchRecordOutputTypeDef,
    SearchResponseOutputTypeDef,
)


def get_structure() -> ActionSourceOutputTypeDef:
    return {...}
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for `boto3`
updates. It delivers drop-in type annotations for you and makes sure that:

- All available `boto3` services are covered.
- Each public class and method of every `boto3` service gets valid type
  annotations extracted from `botocore` schemas.
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore`, `aiobotocore` and `aioboto3`
  libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.resource` calls
- Auto discovery of types for `session.client` and `session.resource` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`mypy-boto3-sagemaker` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[boto3 docs](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_sagemaker/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
